************************************************************************
* File (cc-qcd_br_2221_1413.f) created on Tue Jun 16 11:00:41 MSD 2009.
************************************************************************
* This is the FORTRAN module (cc_qcd_br_2221_1413) to calculate QCD Born
* width and soft photon Bremsstrahlung
* for tp -> bt + dn + up decay.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2009.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine cc_qcd_br_2221_1413 (qs,ts,us,born,soft,hard)
      implicit none!
      include 's2n_declare.h'

      real*8 born1
      complex*16 propws,propiws,propwsc

      cmw2 = mw2
      s = -qs
      t = -ts
      u = -us

      betaf = mtp**2-s

      propiws = (cmw2-s)
      propws = 1d0/propiws
      propwsc = dconjg(propws)

      born=
     & +propws*propwsc/pi**3*gf**2*mw**4*(-3d0/16/mtp**3*u**2+3d0/16/mtp
     & *u)

      born1 = born
      born = born1*betaf/2d0
      virt = 0d0
      soft = 0d0
      hard = 0d0

      if (iborn.eq.1) return

      born = born1

      softvirt=
     & +born/pi*alphas*cf*(-4-2*ddilog(1d0/mtp**2*s))
     & +propws*propwsc*log(1-1d0/mtp**2*s)/pi**4*alphas*gf**2*mw**4*cf*(
     & 3d0/32*1d0/(mtp**2-s)/mtp**3*s**2*u-3d0/32*1d0/(mtp**2-s)/mtp*s*u
     & +3d0/32/mtp**3*s*u-3d0/32/mtp*u)
     & +propws*propwsc*log(1d0/mtp**2*mbt**2)/pi**4*alphas*gf**2*mw**4*c
     & f*(-3d0/64*1d0/(mtp**2-s)/mtp**3*s**2*u+3d0/64*1d0/(mtp**2-s)/mtp
     & *s*u-3d0/64/mtp**3*s*u)
     & +log(1-1d0/mtp**2*s)*born/pi*alphas*cf*(5d0/2)
     & +log(1-1d0/mtp**2*s)**2*born/pi*alphas*cf*(-2)
     & +log(4*omega**2/s)*born/pi*alphas*cf*(-2)
     & +log(4*omega**2/s)*log(1-1d0/mtp**2*s)*born/pi*alphas*cf*(1)
     & +log(4*omega**2/s)*log(mup**2/s)*born/pi*alphas*cf*(-1d0/2)
     & +log(4*omega**2/s)*log(mdn**2/s)*born/pi*alphas*cf*(-1d0/2)
     & +log(4*omega**2/s)*log(1d0/mtp**2*mbt**2)*born/pi*alphas*cf*(-1d0
     & /2)
     & +log(mup**2/s)*born/pi*alphas*cf*(-3d0/4)
     & +log(mdn**2/s)*born/pi*alphas*cf*(-3d0/4)
     & +log(1d0/mtp**2*mbt**2)*born/pi*alphas*cf*(-3d0/4)
     & +log(1d0/mtp**2*mbt**2)*log(1-1d0/mtp**2*s)*born/pi*alphas*cf*(1)
     & +log(1d0/mtp**2*mbt**2)*log(1d0/mtp**2*s)*born/pi*alphas*cf*(-1)
     & +log(1d0/mtp**2*s)*born/pi*alphas*cf*(-2-1d0/(mtp**2-s)*s)
     & +log(1d0/mtp**2*s)*log(1-1d0/mtp**2*s)*born/pi*alphas*cf*(1)

      soft = softvirt*betaf/2

      return
      end
************************************************************************
* This is the FORTRAN module (cc_qcd_ha_2221_1413_1spr) to calculate hard
* photon Bremsstrahlung for tp -> bt + dn + up decay.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2009.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine cc_qcd_ha_2221_1413_1spr (s,spr,hard)
      implicit none!
      include 's2n_declare.h'

      complex*16 propiws,propws,propwsc
      complex*16 propiwspr,propwspr,propwsprc

      cmw2 = mw2

      propiws = (cmw2-s)
      propws = 1d0/propiws
      propwsc = dconjg(propws)
      propiwspr = (cmw2-spr)
      propwspr = 1d0/propiwspr
      propwsprc = dconjg(propwspr)

      hard=
     & +propws*propwsc/pi**4*alphas*gf**2*mw**4/(s-spr)*cf*(-1d0/8/mtp**
     & 3*s**3+3d0/16/mtp*s**2-1d0/16*mtp**3)
     & +propws*propwsc/pi**4*alphas*gf**2*mw**4*(s-spr)*cf*(-1d0/16/mtp*
     & *3*s+3d0/32/mtp-1d0/32*mtp**3/s**2)
     & +propws*propwsc/pi**4*alphas*gf**2*mw**4*cf*(1d0/8/mtp**3*s**2-3d
     & 0/16/mtp*s+1d0/16*mtp**3/s)
     & +propws*propwsc*log(1d0/mup**2*spr)/pi**4*alphas*gf**2*mw**4/(s-s
     & pr)*cf*(1d0/16/mtp**3*s**3-3d0/32/mtp*s**2+1d0/32*mtp**3)
     & +propws*propwsc*log(1d0/mup**2*spr)/pi**4*alphas*gf**2*mw**4*(s-s
     & pr)*cf*(1d0/32/mtp**3*s-3d0/64/mtp+1d0/64*mtp**3/s**2)
     & +propws*propwsc*log(1d0/mup**2*spr)/pi**4*alphas*gf**2*mw**4*cf*(
     & -1d0/16/mtp**3*s**2+3d0/32/mtp*s-1d0/32*mtp**3/s)
     & +propws*propwsc*log(1d0/mdn**2*spr)/pi**4*alphas*gf**2*mw**4/(s-s
     & pr)*cf*(1d0/16/mtp**3*s**3-3d0/32/mtp*s**2+1d0/32*mtp**3)
     & +propws*propwsc*log(1d0/mdn**2*spr)/pi**4*alphas*gf**2*mw**4*(s-s
     & pr)*cf*(1d0/32/mtp**3*s-3d0/64/mtp+1d0/64*mtp**3/s**2)
     & +propws*propwsc*log(1d0/mdn**2*spr)/pi**4*alphas*gf**2*mw**4*cf*(
     & -1d0/16/mtp**3*s**2+3d0/32/mtp*s-1d0/32*mtp**3/s)
     & +propwspr*propwsprc/pi**4*alphas*gf**2*mw**4/(s-spr)*cf*(-1d0/8/m
     & tp**3*s**3+3d0/16/mtp*s**2-1d0/16*mtp**3)
     & +propwspr*propwsprc/pi**4*alphas*gf**2*mw**4*(s-spr)*cf*(-3d0/16/
     & mtp**3*s+3d0/16/mtp)
     & +propwspr*propwsprc/pi**4*alphas*gf**2*mw**4*(s-spr)**2*cf*(1d0/1
     & 6/mtp**3-1d0/16/mtp/s)
     & +propwspr*propwsprc/pi**4*alphas*gf**2*mw**4*cf*(1d0/4/mtp**3*s**
     & 2-5d0/16/mtp*s+1d0/16*mtp)
     & +propwspr*propwsprc*log(1-1d0/mtp**2*s)/pi**4*alphas*gf**2*mw**4/
     & (s-spr)*cf*(1d0/8/mtp**3*s**3-3d0/16/mtp*s**2+1d0/16*mtp**3)
     & +propwspr*propwsprc*log(1-1d0/mtp**2*s)/pi**4*alphas*gf**2*mw**4*
     & (s-spr)*cf*(3d0/16/mtp**3*s-3d0/32/mtp)
     & +propwspr*propwsprc*log(1-1d0/mtp**2*s)/pi**4*alphas*gf**2*mw**4*
     & (s-spr)**2*cf*(-1d0/16/mtp**3)
     & +propwspr*propwsprc*log(1-1d0/mtp**2*s)/pi**4*alphas*gf**2*mw**4*
     & cf*(-1d0/4/mtp**3*s**2+5d0/16/mtp*s-1d0/16*mtp)
     & +propwspr*propwsprc*log(1d0/mtp**2*mbt**2)/pi**4*alphas*gf**2*mw*
     & *4/(s-spr)*cf*(-1d0/16/mtp**3*s**3+3d0/32/mtp*s**2-1d0/32*mtp**3)
     & 
     & +propwspr*propwsprc*log(1d0/mtp**2*mbt**2)/pi**4*alphas*gf**2*mw*
     & *4*(s-spr)*cf*(-3d0/32/mtp**3*s+3d0/64/mtp)
     & +propwspr*propwsprc*log(1d0/mtp**2*mbt**2)/pi**4*alphas*gf**2*mw*
     & *4*(s-spr)**2*cf*(1d0/32/mtp**3)
     & +propwspr*propwsprc*log(1d0/mtp**2*mbt**2)/pi**4*alphas*gf**2*mw*
     & *4*cf*(1d0/8/mtp**3*s**2-5d0/32/mtp*s+1d0/32*mtp)

      return
      end
