************************************************************************
* File (cc_br_2122_1112.f) created on Tue May 26 22:36:09 MSD 2009.
************************************************************************
* This is the FORTRAN module (cc_bo_2122_1112) to calculate EW
* integrated Born width for anti-tp -> anti-bt + en + el decay.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2009.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine cc_bo_2122_1112 (s,born)
      implicit none!
      include 's2n_declare.h'

      complex*16 propws,propiws,propwsc

      cmw2 = mw2

      if (irun.eq.0) then
         propiws = (cmw2-s)
      elseif (irun.eq.1) then
         propiws = (dcmplx(mw**2,-s*ww/mw)-s)
      endif
      propws = 1d0/propiws
      propwsc = dconjg(propws)

      born=
     & +propws*propwsc/pi**3*gf**2*mw**4*(1d0/48/mtp**3*s**3-1d0/32/mtp*
     & s**2+1d0/96*mtp**3)

      return
      end
************************************************************************
* This is the FORTRAN module (cc_br_2122_1112) to calculate EW Born
* width and soft photon Bremsstrahlung
* for anti-tp -> anti-bt + en + el decay.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2009.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine cc_br_2122_1112 (qs,ts,us,born,soft,hard)
      implicit none!
      include 's2n_declare.h'

      real*8 qw,softvirtisr,softvirtfsr,softvirtifi
      complex*16 propws,propiws,propwsc

      cmw2 = mw2
      qw   = 1d0

      s = -qs
      t = -ts
      u = -us

      cosf = (u-t)/(mtp**2-s)
      sinf = dsqrt(1d0-cosf**2)

      if (irun.eq.0) then
         propiws = (cmw2-s)
      elseif (irun.eq.1) then
         propiws = (dcmplx(mw**2,-s*ww/mw)-s)
      endif
      propws = 1d0/propiws
      propwsc = dconjg(propws)

      betaf = mtp**2-s

      born=
     & +propws*propwsc/pi**3*gf**2*mw**4*(-1d0/16/mtp**3*u**2+1d0/16/mtp
     & *u)

      born = born*betaf/2d0
      virt = 0d0
      soft = 0d0
      hard = 0d0

      if (iborn.eq.1) return


      softvirtisr=
     & +born/pi*alpha*qw**2*(1)
     & +born/pi*alpha*qtp**2*(3d0/4)
     & +born/pi*alpha*qbt**2*(3d0/4)
     & +log(mtp**2/thmu2)*born/pi*alpha*qtp**2*(-3d0/4)
     & +log(mtp**2/thmu2)*born/pi*alpha*qbt**2*(-3d0/4)
     & +log(-1+mtp**2/s)*born/pi*alpha*qbt**2*(1)
     & +log(-1+mtp**2/s)**2*born/pi*alpha*qw*qbt*(1)
     & +log(-1+mtp**2/s)**2*born/pi*alpha*qtp*qbt*(-2)
     & +log(4*omega**2/mtp**2)*born/pi*alpha*qw*qtp*(-1d0/2)
     & +log(4*omega**2/mtp**2)*born/pi*alpha*qw*qbt*(1d0/2)
     & +log(4*omega**2/mtp**2)*born/pi*alpha*qtp**2*(-1d0/2)
     & +log(4*omega**2/mtp**2)*born/pi*alpha*qbt**2*(-1d0/2)
     & +log(4*omega**2/mtp**2)*log(-1+mtp**2/s)*born/pi*alpha*qbt**2*(1)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*mbt**2)*born/pi*alpha*(-1d
     & 0/18)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*qtp*qbt*(
     & 1+1d0/(mtp**2-s)*s)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*qtp**2*(-
     & 1d0/2-1d0/(mtp**2-s)*s)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*qbt**2*(1
     & d0/2)
     & +log(1d0/mtp**2*mbt**2)*born/pi*alpha*(-1d0/12)
     & +log(1d0/mtp**2*mbt**2)*log(-1+mtp**2/s)*born/pi*alpha*(1d0/9)
     & +log(1d0/mtp**2*mbt**2)**2*born/pi*alpha*(-1d0/12)
     & +log(1d0/mtp**2*mbt**2)*log(1d0/mtp**2*s)*born/pi*alpha*(1d0/18)
     & +log(1d0/mtp**2*s)*born/pi*alpha*qtp**2*(-1d0/2-1d0/(mtp**2-s)*s)
     & +log(1d0/mtp**2*s)*born/pi*alpha*qbt**2*(1d0/2)
     & +log(1d0/mtp**2*s)*log(-1+mtp**2/s)*born/pi*alpha*qw*qtp*(1+2*1d0
     & /(mtp**2-s)*s)
     & +log(1d0/mtp**2*s)*log(-1+mtp**2/s)*born/pi*alpha*qw*qbt*(1)
     & +log(1d0/mtp**2*s)*log(-1+mtp**2/s)*born/pi*alpha*qtp*qbt*(-4)
     & +log(1d0/mtp**2*s)**2*born/pi*alpha*qw*qtp*(3d0/4+3d0/2*1d0/(mtp*
     & *2-s)*s)
     & +log(1d0/mtp**2*s)**2*born/pi*alpha*qw*qbt*(1d0/4)
     & +log(1d0/mtp**2*s)**2*born/pi*alpha*qtp*qbt*(-2)
     & +ddilog(1d0/mtp**2*s)*born/pi*alpha*qw*qtp*(1+2*1d0/(mtp**2-s)*s)
     & +ddilog(1d0/mtp**2*s)*born/pi*alpha*qtp*qbt*(-2)
     & +ddilog(1d0)*born/pi*alpha*qw*qtp*(-1-2*1d0/(mtp**2-s)*s)
     & +ddilog(1d0)*born/pi*alpha*qw*qbt*(1)

      softvirtfsr=
     & +born/pi*alpha*qw**2*(1)
     & +born/pi*alpha*qel**2*(3d0/4)
     & +log(mtp**2/thmu2)*born/pi*alpha*qel**2*(-3d0/4)
     & +log(4*omega**2/mtp**2)*born/pi*alpha*qw*qtp*(-1d0/2)
     & +log(4*omega**2/mtp**2)*born/pi*alpha*qw*qbt*(1d0/2)
     & +log(4*omega**2/mtp**2)*born/pi*alpha*qel**2*(-1d0/2)
     & +log(4*omega**2/mtp**2)*log(mel**2/mtp**2)*born/pi*alpha*qel**2*(
     & -1d0/2)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*qel*qtp*(
     & -1d0/2)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*qel*qbt*(
     & 1d0/2)
     & +log(mel**2/mtp**2)*born/pi*alpha*qel**2*(-3d0/4)
     & +log(mel**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*qel**2*(1d0/2
     & )
     & +log(1d0/mtp**2*s)*born/pi*alpha*qel**2*(1d0/2)
     & +log(1d0/mtp**2*s)**2*born/pi*alpha*qw*qel*(1d0/4)
     & +ddilog(1d0)*born/pi*alpha*qw*qel*(1)

      softvirtifi=
     & +born/pi*alpha*qw**2*(-2)
     & +log(-1+mtp**2/s)**2*born/pi*alpha*qw*qbt*(-1)
     & +log(-1+mtp**2/s)**2*born/pi*alpha*qel*qbt*(-1)
     & +log(1-1d0/mtp**2*u)**2*born/pi*alpha*qel*qtp*(1d0/2)
     & +log(4*omega**2/mtp**2)*born/pi*alpha*qw*qtp*(1)
     & +log(4*omega**2/mtp**2)*born/pi*alpha*qw*qbt*(-1)
     & +log(4*omega**2/mtp**2)*log(-1+mtp**2/s)*born/pi*alpha*qtp*qbt*(1
     & )
     & +log(4*omega**2/mtp**2)*log(-1+mtp**2/s)*born/pi*alpha*qbt**2*(-1
     & )
     & +log(4*omega**2/mtp**2)*log(1-1d0/mtp**2*u)*born/pi*alpha*qel*qtp
     & *(-1)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*qel*qtp*(
     & 1d0/2)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*qel*qbt*(
     & -1d0/2)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*qtp*qbt*(
     & -1d0/(mtp**2-s)*s)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*qtp**2*(1
     & d0/2+1d0/(mtp**2-s)*s)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*qbt**2*(-
     & 1d0/2)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*t)*born/pi*alpha*qel*qbt*(
     & 1)
     & +log(1d0/mtp**2*mbt**2)**2*born/pi*alpha*(1d0/12)
     & +log(1d0/mtp**2*s)*log(-1+mtp**2/s)*born/pi*alpha*qw*qtp*(-1-2*1d
     & 0/(mtp**2-s)*s)
     & +log(1d0/mtp**2*s)*log(-1+mtp**2/s)*born/pi*alpha*qw*qbt*(-1)
     & +log(1d0/mtp**2*s)*log(-1+mtp**2/s)*born/pi*alpha*qel*qbt*(-1)
     & +log(1d0/mtp**2*s)**2*born/pi*alpha*qw*qel*(-1d0/4)
     & +log(1d0/mtp**2*s)**2*born/pi*alpha*qw*qtp*(-3d0/4-3d0/2*1d0/(mtp
     & **2-s)*s)
     & +log(1d0/mtp**2*s)**2*born/pi*alpha*qw*qbt*(-1d0/4)
     & +log(1d0/mtp**2*s)**2*born/pi*alpha*qel*qtp*(1d0/2)
     & +log(1d0/mtp**2*s)**2*born/pi*alpha*qel*qbt*(-1d0/2)
     & +log(1d0/mtp**2*t)**2*born/pi*alpha*qel*qbt*(-1d0/2)
     & +ddilog(1d0/mtp**2*s)*born/pi*alpha*qw*qtp*(-1-2*1d0/(mtp**2-s)*s
     & )
     & +ddilog(-1d0/t*u)*born/pi*alpha*qel*qbt*(-1)
     & +ddilog(1/(mtp**2-u)*t)*born/pi*alpha*qel*qtp*(1)
     & +ddilog(1d0)*born/pi*alpha*qw*qel*(-1)
     & +ddilog(1d0)*born/pi*alpha*qw*qtp*(1+2*1d0/(mtp**2-s)*s)
     & +ddilog(1d0)*born/pi*alpha*qw*qbt*(-1)
     & +ddilog(1d0)*born/pi*alpha*qel*qtp*(1)
     & +ddilog(1d0)*born/pi*alpha*qel*qbt*(2)

      if (iqed.eq.1) then
         soft = softvirtisr+softvirtfsr+softvirtifi
      elseif(iqed.eq.2) then
         soft = softvirtisr
      elseif(iqed.eq.3) then
         soft = softvirtifi
      elseif(iqed.eq.4) then
         soft = softvirtfsr
      endif

      soft = soft*cfprime

      return
      end
************************************************************************
* This is the FORTRAN module (cc_ha_2122_1112_1spr) to calculate hard
* photon Bremsstrahlung for anti-tp -> anti-bt + en + el decay.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2009.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine cc_ha_2122_1112_1spr (s,spr,hard)
      implicit none!
      include 's2n_declare.h'

      real*8 qw,mds,mdspr,md2spr,mds2spr
      complex*16 propiwspr,propwspr,propwsprc
      complex*16 propws,propiws,propwsc

      cmw2 = mw2
      qw   = 1d0

      if (irun.eq.0) then
         propiws = (cmw2-s)
      elseif (irun.eq.1) then
         propiws = (dcmplx(mw**2,-s*ww/mw)-s)
      endif
      propws = 1d0/propiws
      propwsc = dconjg(propws)
      mds = propws*propwsc
      if (irun.eq.0) then
         propiwspr = (cmw2-spr)
      elseif (irun.eq.1) then
         propiwspr = (dcmplx(mw**2,-spr*ww/mw)-spr)
      endif
      propwspr = 1d0/propiwspr
      propwsprc = dconjg(propwspr)
      mdspr = propwspr*propwsprc
      md2spr = propwspr + propwsprc
      mds2spr = propws*propwsprc + propwspr*propwsc

      hardisr=
     & +mdspr/pi**4*alpha*g**4*qw*qtp*(-1d0/1024*(mtp**2-s)/mtp**3*s+1d0
     & /768*(mtp**2-s)/mtp**3*(s-spr)
     & +1d0/2048*(mtp**2-s)**2/mtp**3/s**2*(s-spr)**2-1d0/6144*(mtp**2-s
     & )**2/mtp**3/s*(s-spr)
     & -1d0/1536*(mtp**2-s)**2/mtp**3+1d0/9216*(mtp**2-s)**3/mtp**3/s**3
     & *(s-spr)**2-1d0/6144*(mtp**2-s)**3/mtp**3/s**2*(s-spr)
     & -1d0/3072*(mtp**2-s)**3/mtp**3/s)+mdspr/pi**4*alpha*g**4*qw*qbt*(
     & 1d0/1536*(mtp**2-s)/mtp**3/s*(s-spr)**2+1d0/1024*(mtp**2-s)/mtp**
     & 3*s-5d0/3072*(mtp**2-s)/mtp**3*(s-spr)
     & +1d0/6144*(mtp**2-s)**2/mtp**3/s**2*(s-spr)**2-1d0/6144*(mtp**2-s
     & )**2/mtp**3/s*(s-spr)
     & +1d0/1536*(mtp**2-s)**2/mtp**3-1d0/9216*(mtp**2-s)**3/mtp**3/s**3
     & *(s-spr)**2+1d0/6144*(mtp**2-s)**3/mtp**3/s**2*(s-spr)
     & +1d0/3072*(mtp**2-s)**3/mtp**3/s)
     & +mdspr/pi**4*alpha*g**4*qw**2*(-1d0/2048*(mtp**2-s)**2/mtp**3/s**
     & 2*(s-spr)**2+1d0/1536*(mtp**2-s)**2/mtp**3/s*(s-spr)
     & -1d0/1024*(mtp**2-s)**2/mtp**3*s/(s-spr)+1d0/1024*(mtp**2-s)**2/m
     & tp**3-1d0/3072*(mtp**2-s)**3/mtp**3/s**3*(s-spr)**2+7d0/18432*(mt
     & p**2-s)**3/mtp**3/s**2*(s-spr)
     & +1d0/3072*(mtp**2-s)**3/mtp**3/s-1d0/3072*(mtp**2-s)**3/mtp**3/(s
     & -spr))
     & +mdspr/pi**4*alpha*g**4*qtp*qbt*(1d0/1536*(mtp**2-s)/mtp**3*(s-sp
     & r)
     & +1d0/3072*(mtp**2-s)**2/mtp**3/s*(s-spr))
     & +mdspr/pi**4*alpha*g**4*qtp**2*(-1d0/3072*(mtp**2-s)/mtp**3/s*(s-
     & spr)**2-1d0/1024*(mtp**2-s)/mtp**3*s+1d0/2048*(mtp**2-s)/mtp**3*(
     & s-spr)
     & -1d0/3072*(mtp**2-s)**2/mtp**3/s*(s-spr)-1d0/1024*(mtp**2-s)**2/m
     & tp**3*s/(s-spr)+1d0/3072*(mtp**2-s)**2/mtp**3-1d0/3072*(mtp**2-s)
     & **3/mtp**3/(s-spr))
     & +mdspr/pi**4*alpha*g**4*qbt**2*(-1d0/3072*(mtp**2-s)/mtp**3/s*(s-
     & spr)**2-1d0/1024*(mtp**2-s)/mtp**3*s+5d0/6144*(mtp**2-s)/mtp**3*(
     & s-spr)
     & -1d0/1024*(mtp**2-s)**2/mtp**3*s/(s-spr)+1d0/3072*(mtp**2-s)**2/m
     & tp**3-1d0/3072*(mtp**2-s)**3/mtp**3/(s-spr))
     & +log(1-1d0/mtp**2*s)*mdspr/pi**4*alpha*g**4*qw*qbt*(-1d0/512*(mtp
     & **2-s)/mtp**3*s+1d0/768*(mtp**2-s)/mtp**3*(s-spr)
     & -1d0/512*(mtp**2-s)**2/mtp**3*s/(s-spr)+1d0/1536*(mtp**2-s)**2/mt
     & p**3-1d0/1536*(mtp**2-s)**3/mtp**3/(s-spr))
     & +log(1-1d0/mtp**2*s)*mdspr/pi**4*alpha*g**4*qtp*qbt*(1d0/512*(mtp
     & **2-s)/mtp**3*s-1d0/768*(mtp**2-s)/mtp**3*(s-spr)
     & +1d0/512*(mtp**2-s)**2/mtp**3*s/(s-spr)
     & -1d0/1536*(mtp**2-s)**2/mtp**3+1d0/1536*(mtp**2-s)**3/mtp**3/(s-s
     & pr))
     & +log(1-1d0/mtp**2*s)*mdspr/pi**4*alpha*g**4*qbt**2*(1d0/3072*(mtp
     & **2-s)/mtp**3*(s-spr)
     & +1d0/1024/mtp**3*s*(s-spr)
     & -1d0/1536/mtp**3*(s-spr)**2)+log(1d0/mtp**2*mbt**2)*mdspr/pi**4*a
     & lpha*g**4*qw*qbt*(1d0/1024*(mtp**2-s)/mtp**3*s-1d0/1536*(mtp**2-s
     & )/mtp**3*(s-spr)
     & +1d0/1024*(mtp**2-s)**2/mtp**3*s/(s-spr)
     & -1d0/3072*(mtp**2-s)**2/mtp**3+1d0/3072*(mtp**2-s)**3/mtp**3/(s-s
     & pr))
     & +log(1d0/mtp**2*mbt**2)*mdspr/pi**4*alpha*g**4*qtp*qbt*(-1d0/1024
     & *(mtp**2-s)/mtp**3*s+1d0/1536*(mtp**2-s)/mtp**3*(s-spr)
     & -1d0/1024*(mtp**2-s)**2/mtp**3*s/(s-spr)+1d0/3072*(mtp**2-s)**2/m
     & tp**3-1d0/3072*(mtp**2-s)**3/mtp**3/(s-spr))
     & +log(1d0/mtp**2*mbt**2)*mdspr/pi**4*alpha*g**4*qbt**2*(-1d0/6144*
     & (mtp**2-s)/mtp**3*(s-spr)
     & -1d0/2048/mtp**3*s*(s-spr)+1d0/3072/mtp**3*(s-spr)**2)
     & +log(1d0/mtp**2*s)*mdspr/pi**4*alpha*g**4*qw*qtp*(1d0/768*(mtp**2
     & -s)/mtp**3*s-1d0/512*(mtp**2-s)/mtp**3*s**2/(s-spr)
     & +1d0/1536*(mtp**2-s)/mtp**3*(s-spr)
     & -5d0/3072*(mtp**2-s)**2/mtp**3*s/(s-spr)+1d0/1024*(mtp**2-s)**2/m
     & tp**3-1d0/3072*(mtp**2-s)**3/mtp**3/(s-spr)
     & +1d0/768/mtp**3*s*(s-spr)
     & -1d0/1024/mtp**3*s**2)+log(1d0/mtp**2*s)*mdspr/pi**4*alpha*g**4*q
     & w*qbt*(1d0/1024*(mtp**2-s)/mtp**3*s-1d0/1536*(mtp**2-s)/mtp**3*(s
     & -spr)
     & +1d0/1024*(mtp**2-s)**2/mtp**3*s/(s-spr)
     & -1d0/3072*(mtp**2-s)**2/mtp**3+1d0/3072*(mtp**2-s)**3/mtp**3/(s-s
     & pr))
     & +log(1d0/mtp**2*s)*mdspr/pi**4*alpha*g**4*qtp*qbt*(5d0/3072*(mtp*
     & *2-s)/mtp**3*s+1d0/1536*(mtp**2-s)**2/mtp**3+1d0/1024/mtp**3*s**2
     & )
     & +log(1d0/mtp**2*s)*mdspr/pi**4*alpha*g**4*qtp**2*(-5d0/3072*(mtp*
     & *2-s)/mtp**3*s+1d0/6144*(mtp**2-s)/mtp**3*(s-spr)
     & -1d0/1536*(mtp**2-s)**2/mtp**3+1d0/2048/mtp**3*s*(s-spr)
     & -1d0/1024/mtp**3*s**2-1d0/3072/mtp**3*(s-spr)**2)+log(1d0/mtp**2*
     & s)*mdspr/pi**4*alpha*g**4*qbt**2*(-1d0/6144*(mtp**2-s)/mtp**3*(s-
     & spr)
     & -1d0/2048/mtp**3*s*(s-spr)+1d0/3072/mtp**3*(s-spr)**2)

      hardfsr=
     & +mds/pi**4*alpha*g**4*qw*qel*(-1d0/1024*(mtp**2-s)**2/mtp**3/s**2
     & *(s-spr)**2+3d0/2048*(mtp**2-s)**2/mtp**3/s*(s-spr)
     & -1d0/1536*(mtp**2-s)**3/mtp**3/s**3*(s-spr)**2+5d0/6144*(mtp**2-s
     & )**3/mtp**3/s**2*(s-spr))
     & +mds/pi**4*alpha*g**4*qw**2*(-1d0/2048*(mtp**2-s)**2/mtp**3/s**2*
     & (s-spr)**2+1d0/1536*(mtp**2-s)**2/mtp**3/s*(s-spr)
     & -1d0/1024*(mtp**2-s)**2/mtp**3*s/(s-spr)+1d0/1024*(mtp**2-s)**2/m
     & tp**3-1d0/3072*(mtp**2-s)**3/mtp**3/s**3*(s-spr)**2+7d0/18432*(mt
     & p**2-s)**3/mtp**3/s**2*(s-spr)
     & +1d0/3072*(mtp**2-s)**3/mtp**3/s-1d0/3072*(mtp**2-s)**3/mtp**3/(s
     & -spr))
     & +mds/pi**4*alpha*g**4*qel**2*(-1d0/2048*(mtp**2-s)**2/mtp**3/s**2
     & *(s-spr)**2-1d0/1024*(mtp**2-s)**2/mtp**3*s/(s-spr)
     & +1d0/1024*(mtp**2-s)**2/mtp**3-1d0/3072*(mtp**2-s)**3/mtp**3/s**3
     & *(s-spr)**2+1d0/6144*(mtp**2-s)**3/mtp**3/s**2*(s-spr)
     & +1d0/3072*(mtp**2-s)**3/mtp**3/s-1d0/3072*(mtp**2-s)**3/mtp**3/(s
     & -spr))
     & +log(1d0/mel**2*spr)*mds/pi**4*alpha*g**4*qw*qel*(-1d0/1024*(mtp*
     & *2-s)**2/mtp**3*s/(s-spr)
     & +1d0/1024*(mtp**2-s)**2/mtp**3+1d0/3072*(mtp**2-s)**3/mtp**3/s-1d
     & 0/3072*(mtp**2-s)**3/mtp**3/(s-spr))
     & +log(1d0/mel**2*spr)*mds/pi**4*alpha*g**4*qel**2*(1d0/2048*(mtp**
     & 2-s)**2/mtp**3/s*(s-spr)
     & +1d0/6144*(mtp**2-s)**3/mtp**3/s**2*(s-spr))

      hardifi=
     & +1d0/pi**4*alpha*g**4*qw*qel*mds2spr*(1d0/2048*(mtp**2-s)**2/mtp*
     & *3/s**2*(s-spr)**2-3d0/4096*(mtp**2-s)**2/mtp**3/s*(s-spr)
     & +1d0/3072*(mtp**2-s)**3/mtp**3/s**3*(s-spr)**2-5d0/12288*(mtp**2-
     & s)**3/mtp**3/s**2*(s-spr))
     & +1d0/pi**4*alpha*g**4*qw*qtp*mds2spr*(1d0/2048*(mtp**2-s)/mtp**3*
     & s-1d0/1536*(mtp**2-s)/mtp**3*(s-spr)
     & -1d0/4096*(mtp**2-s)**2/mtp**3/s**2*(s-spr)**2+1d0/12288*(mtp**2-
     & s)**2/mtp**3/s*(s-spr)
     & +1d0/3072*(mtp**2-s)**2/mtp**3-1d0/18432*(mtp**2-s)**3/mtp**3/s**
     & 3*(s-spr)**2+1d0/12288*(mtp**2-s)**3/mtp**3/s**2*(s-spr)
     & +1d0/6144*(mtp**2-s)**3/mtp**3/s)
     & +1d0/pi**4*alpha*g**4*qw*qbt*mds2spr*(-1d0/3072*(mtp**2-s)/mtp**3
     & /s*(s-spr)**2-1d0/2048*(mtp**2-s)/mtp**3*s+5d0/6144*(mtp**2-s)/mt
     & p**3*(s-spr)
     & -1d0/12288*(mtp**2-s)**2/mtp**3/s**2*(s-spr)**2+1d0/12288*(mtp**2
     & -s)**2/mtp**3/s*(s-spr)
     & -1d0/3072*(mtp**2-s)**2/mtp**3+1d0/18432*(mtp**2-s)**3/mtp**3/s**
     & 3*(s-spr)**2-1d0/12288*(mtp**2-s)**3/mtp**3/s**2*(s-spr)
     & -1d0/6144*(mtp**2-s)**3/mtp**3/s)+1d0/pi**4*alpha*g**4*qw**2*mds2
     & spr*(1d0/2048*(mtp**2-s)**2/mtp**3/s**2*(s-spr)**2-1d0/1536*(mtp*
     & *2-s)**2/mtp**3/s*(s-spr)
     & +1d0/1024*(mtp**2-s)**2/mtp**3*s/(s-spr)
     & -1d0/1024*(mtp**2-s)**2/mtp**3+1d0/3072*(mtp**2-s)**3/mtp**3/s**3
     & *(s-spr)**2-7d0/18432*(mtp**2-s)**3/mtp**3/s**2*(s-spr)
     & -1d0/3072*(mtp**2-s)**3/mtp**3/s+1d0/3072*(mtp**2-s)**3/mtp**3/(s
     & -spr))
     & +1d0/pi**4*alpha*g**4*qel*qtp*mds2spr*(1d0/3072*(mtp**2-s)/mtp**3
     & *s**2/(s-spr)
     & -1d0/2048*(mtp**2-s)/mtp**3*(s-spr)-1d0/4096*(mtp**2-s)**2/mtp**3
     & /s**2*(s-spr)**2+1d0/12288*(mtp**2-s)**2/mtp**3/s*(s-spr)
     & +5d0/6144*(mtp**2-s)**2/mtp**3*s/(s-spr)
     & -1d0/2048*(mtp**2-s)**2/mtp**3-1d0/18432*(mtp**2-s)**3/mtp**3/s**
     & 3*(s-spr)**2+1d0/12288*(mtp**2-s)**3/mtp**3/s**2*(s-spr)
     & -1d0/6144*(mtp**2-s)**3/mtp**3/s+5d0/18432*(mtp**2-s)**3/mtp**3/(
     & s-spr))
     & +1d0/pi**4*alpha*g**4*qel*qbt*mds2spr*(-1d0/3072*(mtp**2-s)/mtp**
     & 3/s*(s-spr)**2-1d0/1024*(mtp**2-s)/mtp**3*s+7d0/6144*(mtp**2-s)/m
     & tp**3*(s-spr)
     & -1d0/12288*(mtp**2-s)**2/mtp**3/s**2*(s-spr)**2+1d0/12288*(mtp**2
     & -s)**2/mtp**3/s*(s-spr)
     & -3d0/2048*(mtp**2-s)**2/mtp**3*s/(s-spr)+1d0/1024*(mtp**2-s)**2/m
     & tp**3+1d0/18432*(mtp**2-s)**3/mtp**3/s**3*(s-spr)**2-1d0/12288*(m
     & tp**2-s)**3/mtp**3/s**2*(s-spr)
     & +1d0/6144*(mtp**2-s)**3/mtp**3/s-5d0/18432*(mtp**2-s)**3/mtp**3/(
     & s-spr))
     & +log(1-1d0/mtp**2*s)/pi**4*alpha*g**4*qw*qbt*mds2spr*(1d0/1024*(m
     & tp**2-s)/mtp**3*s-1d0/1536*(mtp**2-s)/mtp**3*(s-spr)
     & +1d0/1024*(mtp**2-s)**2/mtp**3*s/(s-spr)
     & -1d0/3072*(mtp**2-s)**2/mtp**3+1d0/3072*(mtp**2-s)**3/mtp**3/(s-s
     & pr))
     & +log(1-1d0/mtp**2*s)/pi**4*alpha*g**4*qel*qbt*mds2spr*(1d0/1024*(
     & mtp**2-s)/mtp**3*s-1d0/1536*(mtp**2-s)/mtp**3*(s-spr)
     & +1d0/1024*(mtp**2-s)**2/mtp**3*s/(s-spr)
     & -1d0/3072*(mtp**2-s)**2/mtp**3+1d0/3072*(mtp**2-s)**3/mtp**3/(s-s
     & pr))
     & +log(1d0/mel**2*spr)/pi**4*alpha*g**4*qw*qel*mds2spr*(1d0/2048*(m
     & tp**2-s)**2/mtp**3*s/(s-spr)
     & -1d0/2048*(mtp**2-s)**2/mtp**3-1d0/6144*(mtp**2-s)**3/mtp**3/s+1d
     & 0/6144*(mtp**2-s)**3/mtp**3/(s-spr))
     & +log(1d0/mel**2*spr)/pi**4*alpha*g**4*qel*qtp*mds2spr*(-1d0/2048*
     & (mtp**2-s)**2/mtp**3*s/(s-spr)
     & +1d0/2048*(mtp**2-s)**2/mtp**3+1d0/6144*(mtp**2-s)**3/mtp**3/s-1d
     & 0/6144*(mtp**2-s)**3/mtp**3/(s-spr))
     & +log(1d0/mel**2*spr)/pi**4*alpha*g**4*qel*qbt*mds2spr*(1d0/2048*(
     & mtp**2-s)**2/mtp**3*s/(s-spr)
     & -1d0/2048*(mtp**2-s)**2/mtp**3-1d0/6144*(mtp**2-s)**3/mtp**3/s+1d
     & 0/6144*(mtp**2-s)**3/mtp**3/(s-spr))
     & +log(1d0/mtp**2*mbt**2)/pi**4*alpha*g**4*qw*qbt*mds2spr*(-1d0/204
     & 8*(mtp**2-s)/mtp**3*s+1d0/3072*(mtp**2-s)/mtp**3*(s-spr)
     & -1d0/2048*(mtp**2-s)**2/mtp**3*s/(s-spr)+1d0/6144*(mtp**2-s)**2/m
     & tp**3-1d0/6144*(mtp**2-s)**3/mtp**3/(s-spr))
     & +log(1d0/mtp**2*mbt**2)/pi**4*alpha*g**4*qel*qbt*mds2spr*(-1d0/20
     & 48*(mtp**2-s)/mtp**3*s+1d0/3072*(mtp**2-s)/mtp**3*(s-spr)
     & -1d0/2048*(mtp**2-s)**2/mtp**3*s/(s-spr)+1d0/6144*(mtp**2-s)**2/m
     & tp**3-1d0/6144*(mtp**2-s)**3/mtp**3/(s-spr))
     & +log(1d0/mtp**2*s)/pi**4*alpha*g**4*qw*qtp*mds2spr*(-1d0/1536*(mt
     & p**2-s)/mtp**3*s+1d0/1024*(mtp**2-s)/mtp**3*s**2/(s-spr)
     & -1d0/3072*(mtp**2-s)/mtp**3*(s-spr)+5d0/6144*(mtp**2-s)**2/mtp**3
     & *s/(s-spr)
     & -1d0/2048*(mtp**2-s)**2/mtp**3+1d0/6144*(mtp**2-s)**3/mtp**3/(s-s
     & pr)
     & -1d0/1536/mtp**3*s*(s-spr)+1d0/2048/mtp**3*s**2)
     & +log(1d0/mtp**2*s)/pi**4*alpha*g**4*qw*qbt*mds2spr*(-1d0/2048*(mt
     & p**2-s)/mtp**3*s+1d0/3072*(mtp**2-s)/mtp**3*(s-spr)
     & -1d0/2048*(mtp**2-s)**2/mtp**3*s/(s-spr)+1d0/6144*(mtp**2-s)**2/m
     & tp**3-1d0/6144*(mtp**2-s)**3/mtp**3/(s-spr))
     & +log(1d0/mtp**2*s)/pi**4*alpha*g**4*qel*qtp*mds2spr*(-1d0/1024*(m
     & tp**2-s)/mtp**3*s+1d0/1024*(mtp**2-s)/mtp**3*s**2/(s-spr)
     & -1d0/6144*(mtp**2-s)/mtp**3*(s-spr)+1d0/2048*(mtp**2-s)**2/mtp**3
     & *s/(s-spr)
     & -1d0/3072*(mtp**2-s)**2/mtp**3+1d0/6144*(mtp**2-s)**3/mtp**3/(s-s
     & pr)
     & -1d0/2048/mtp**3*s*(s-spr)+1d0/3072/mtp**3*s**3/(s-spr))
     & +log(1d0/mtp**2*s)/pi**4*alpha*g**4*qel*qbt*mds2spr*(-1d0/2048*(m
     & tp**2-s)/mtp**3*s+1d0/3072*(mtp**2-s)/mtp**3*(s-spr)
     & -1d0/2048*(mtp**2-s)**2/mtp**3*s/(s-spr)+1d0/6144*(mtp**2-s)**2/m
     & tp**3-1d0/6144*(mtp**2-s)**3/mtp**3/(s-spr))

      if (iqed.eq.1) then
         hard = hardisr+hardfsr+hardifi
      elseif(iqed.eq.2) then
         hard = hardisr
      elseif(iqed.eq.3) then
         hard = hardifi
      elseif(iqed.eq.4) then
         hard = hardfsr
      endif

      hard = hard*cfprime

      return
      end
