************************************************************************
* File (cc_ff_1314_1516.F) created on Wed Dec  3 14:45:58 MSK 2008.
************************************************************************
* This is the FORTRAN module (cc_ff_1314_1516) to calculate 1-loop EW
* form factors for the up + dn -> mn + mo process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2008.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine cc_ff_1314_1516 (qs,ts,us)
      implicit none!
#include "looptools.h"
#include "s2n_declare.h"

      complex*16 ff_qed_ll,ff_qed_ld,ff_qed_rd
      complex*16 ff_ew_ll,ff_ew_ld,ff_ew_rd

      real*8 a0fw,a0fz,a0fh,a0fmo
      complex*16 b0pmozmo,b0pmohmo,b0pmocw
      complex*16 b0fqswz,b0fqswh,b0fqswc,b0fmowc,b0fmozmo,b0fcwmo,b0fts
     & moc,b0ftscc,b0fmohmo,b0fqsmoc,b0fqscc
      complex*16 c0mocqswcz,c0mocqszmow,c0mocqshmow,c0moctsmozc,c0mocts
     & cwc,c0mocusmozc,c0ccqswcz,c0cctscwmo,c0cctsczc,c0ccuscwmo,c0mocqs
     & mozc,c0mocqscmow,c0ccqsczc
      complex*16 b0d2mozmo
      complex*16 d0ccmocqstswczmo,d0ccmocqstszcwc,d0cccmoqsuswczc,d0ccc
     & moqsuszcwmo
      complex*16 javsubqstscmow,javsubqsuscmow
      real*8 sdet3icmoqs,sdet3icmots,sdet3icmous
      real*8 invfmow
      complex*16 propwqs,propiwqs

      common/unibos_bos/za1bos,zmzzzbos,zmwzwbos,zmhzhbos,deltarhobos
      common/unibos_fer/za1fer,zz1fer,zh1fer,zw1fer,zmsqrfer,
     & zmzzzfer,zmwzwfer,zmhzhfer,deltarhofer,tadfer
      common/unipro_fer/caldzfer,caldwfer,pizgfer,piggfer

      cmw2 = mw2

      propiwqs = (cmw2+qs)
      propwqs = 1d0/propiwqs
      a0fw = log(rwm2/thmu2) - 1d0
      a0fz = log(rzm2/thmu2) - 1d0
      a0fh = log(rhm2/thmu2) - 1d0
      a0fmo = log(rmom2/thmu2) - 1d0
      b0pmozmo = b0p(-rmom2,zm2,mom2)
      b0pmohmo = b0p(-rmom2,hm2,mom2)
      b0pmocw = b0p(-rmom2,cm2,wm2)
      b0fqswz = b0f(qs,thmu2,wm2,zm2)
      b0fqswh = b0f(qs,thmu2,wm2,hm2)
      b0fqswc = b0f(qs,thmu2,mw2,cm2)
      b0fmowc = b0f(-rmom2,thmu2,wm2,cm2)
      b0fmozmo = b0f(-rmom2,thmu2,zm2,mom2)
      b0fcwmo = b0f(0d0,thmu2,wm2,mom2)
      b0ftsmoc = b0f(ts,thmu2,mom2,cm2)
      b0ftscc = b0f(ts,thmu2,cm2,cm2)
      b0fmohmo = b0f(-rmom2,thmu2,hm2,mom2)
      b0fqsmoc = b0f(qs,thmu2,mom2,cm2)
      b0fqscc = b0f(qs,thmu2,cm2,cm2)
      c0mocqswcz = c01(-rmom2,1d-6,qs,wm2,cm2,zm2)
      c0mocqszmow = c01(-rmom2,1d-6,qs,zm2,mom2,wm2)
      c0mocqshmow = c01(-rmom2,1d-6,qs,hm2,mom2,wm2)
      c0moctsmozc = c01(-rmom2,0d0,ts,mom2,zm2,cm2)
      c0moctscwc = c01(-rmom2,0d0,ts,cm2,wm2,cm2)
      c0mocusmozc = c01(-rmom2,0d0,us,mom2,zm2,cm2)
      c0ccqswcz = c01(0d0,0d0,qs,wm2,cm2,zm2)
      c0cctscwmo = c01(0d0,0d0,ts,cm2,wm2,mom2)
      c0cctsczc = c01(0d0,0d0,ts,cm2,zm2,cm2)
      c0ccuscwmo = c01(0d0,0d0,us,cm2,wm2,mom2)
      c0mocqsmozc = c01(-rmom2,0d0,qs,mom2,zm2,cm2)
      c0mocqscmow = dreal(c01(-rmom2,0d0,qs,cm2,mom2,mw2))
      c0ccqsczc = c01(0d0,0d0,qs,cm2,zm2,cm2)
      b0d2mozmo = b0d2(-rmom2,thmu2,zm2,mom2)
      d0ccmocqstswczmo =
     & d0(0d0,0d0,rmom2,0d0,-qs,-ts,rwm2,0d0,rzm2,rmom2)
      d0ccmocqstszcwc =
     & d0(0d0,0d0,rmom2,0d0,-qs,-ts,rzm2,0d0,rwm2,0d0)
      d0cccmoqsuswczc =
     & d0(0d0,0d0,0d0,rmom2,-qs,-us,rwm2,0d0,rzm2,0d0)
      d0cccmoqsuszcwmo =
     & d0(0d0,0d0,0d0,rmom2,-qs,-us,rzm2,0d0,rwm2,rmom2)
      javsubqstscmow = javsub(qs,ts,cm2,mom2,mw2)
      javsubqsuscmow = javsub(qs,us,cm2,mom2,mw2)
      sdet3icmoqs = 1d0/(qs+(mmo)**2)
      sdet3icmots = 1d0/(ts+(mmo)**2)
      sdet3icmous = 1d0/(us+(mmo)**2)
      invfmow = 1d0/(1d0-rmom2/rwm2)

      ff_ew_ll =
     & +mmo**2*(-1d0/8*vpamo/mw**2+1d0/8*vmamo/mw**2+1d0/16/mw**2-1d0/8*
     & b0d2mozmo/ctw**2*vmamo**2)
     & +propwqs*a0fw*(-1d0/12/ctw**2*mw**2-5*mw**2+3*mw**4/mh**2-1d0/12*
     & mh**2)
     & +propwqs*a0fz*(1d0/12/ctw**4*mw**2+3d0/2/ctw**4*mw**4/mh**2+2d0/3
     & /ctw**2*mw**2-2*mw**2)
     & +propwqs*a0fh*(-1d0/12/qs*mh**4+1d0/2*mh**2)
     & +propwqs*b0fqswz*(1d0/12/ctw**4*mw**2+4d0/3/ctw**2*mw**2-4*ctw**2
     & *mw**2-17d0/3*mw**2)
     & +propwqs*b0fqswh*(-1d0/12/qs*mh**4+mw**2-1d0/3*mh**2)
     & +propwqs*b0fqswc*(4*ctw**2*mw**2-4*mw**2)
     & +propwqs*(1d0/ctw**4*mw**4/mh**2-1d0/6/ctw**2*mw**2-mw**2*zmwzwbo
     & s-64d0/9*mw**2+2*mw**4/mh**2-1d0/6*mh**2)
     & +propiwqs*mmo**2*(8*ctw**2*qdn*qmo/ts/us-8*qdn*qmo/ts/us)
     & +propiwqs*sdet3icmoqs*mmo**2*(4*ctw**2*qdn*qmo/qs+8*ctw**2*qdn*qm
     & o/ts+8*ctw**2*qdn*qmo/us-4*qdn*qmo/qs-8*qdn*qmo/ts-8*qdn*qmo/us)
     & +propiwqs*sdet3icmoqs**2*c0mocqswcz*(1d0/ctw**4*vpaup*vpamn*ts*mw
     & **2+1d0/ctw**4*vpaup*vpamn*us*mw**2)
     & +propiwqs*sdet3icmoqs**2*c0mocqszmow*mmo**2*(-1d0/ctw**2*vpadn*vp
     & amo*ts-1d0/ctw**2*vpadn*vpamo*us)
     & +propiwqs*sdet3icmoqs**2*c0mocqszmow*(1d0/ctw**2*vpadn*vpamo*ts*m
     & w**2+1d0/ctw**2*vpadn*vpamo*us*mw**2)
     & +propiwqs*sdet3icmoqs**2*b0fmowc*(-1d0/ctw**2*vpaup*vpamn*ts-1d0/
     & ctw**2*vpaup*vpamn*us)
     & +propiwqs*sdet3icmoqs**2*b0fmozmo*(-1d0/ctw**2*vpadn*vpamo*ts-1d0
     & /ctw**2*vpadn*vpamo*us)
     & +propiwqs*sdet3icmoqs**2*b0fqswz*(1d0/ctw**2*vpaup*vpamn*ts+1d0/c
     & tw**2*vpaup*vpamn*us+1d0/ctw**2*vpadn*vpamo*ts+1d0/ctw**2*vpadn*v
     & pamo*us)
     & +propiwqs*sdet3icmoqs**2*b0fqswc*(-4*ctw**2*qdn*qmo*ts-4*ctw**2*q
     & dn*qmo*us+4*qdn*qmo*ts+4*qdn*qmo*us)
     & +propiwqs*sdet3icmoqs**2*(4*ctw**2*qdn*qmo*ts+4*ctw**2*qdn*qmo*us
     & -4*qdn*qmo*ts-4*qdn*qmo*us)
     & +propiwqs*sdet3icmoqs*c0mocqswcz*mmo**2*(1d0/ctw**4*vpaup*vpamn/q
     & s*mw**2+2/ctw**4*vpaup*vpamn/ts*mw**2+2/ctw**4*vpaup*vpamn/us*mw*
     & *2-1d0/2/ctw**2*vpaup*vpamn/qs*mw**2)
     & +propiwqs*sdet3icmoqs*c0mocqswcz*(2/ctw**4*vpaup*vpamn*mw**2+1d0/
     & 2/ctw**2*vpaup*vpamn*ts+1d0/2/ctw**2*vpaup*vpamn*us-1d0/2/ctw**2*
     & vpaup*vpamn*mw**2)
     & +propiwqs*sdet3icmoqs*c0mocqszmow*mmo**2*(-1d0/2/ctw**4*vpadn*vpa
     & mo/qs*mw**2+1d0/ctw**2*vpadn*vpamo/qs*mw**2+2/ctw**2*vpadn*vpamo/
     & ts*mw**2+2/ctw**2*vpadn*vpamo/us*mw**2-1d0/ctw**2*vpadn*vpamo)
     & +propiwqs*sdet3icmoqs*c0mocqszmow*mmo**4*(-2/ctw**2*vpadn*vpamo/t
     & s-2/ctw**2*vpadn*vpamo/us)
     & +propiwqs*sdet3icmoqs*c0mocqszmow*(-1d0/2/ctw**4*vpadn*vpamo*mw**
     & 2+2/ctw**2*vpadn*vpamo*mw**2)
     & +propiwqs*sdet3icmoqs*a0fz*mmo**2*(-1d0/2/ctw**2*vpaup*vpamn/qs)
     & +propiwqs*sdet3icmoqs*a0fz*(-1d0/2/ctw**2*vpaup*vpamn)
     & +propiwqs*sdet3icmoqs*a0fmo*mmo**2*(8*stw**2*qdn*qmo/ts+8*stw**2*
     & qdn*qmo/us)
     & +propiwqs*sdet3icmoqs*b0fmowc*mmo**2*(-1d0/ctw**2*vpaup*vpamn/qs-
     & 2/ctw**2*vpaup*vpamn/ts-2/ctw**2*vpaup*vpamn/us)
     & +propiwqs*sdet3icmoqs*b0fmowc*(-2/ctw**2*vpaup*vpamn)
     & +propiwqs*sdet3icmoqs*b0fmozmo*mmo**2*(-1d0/ctw**2*vpadn*vpamo/qs
     & -2/ctw**2*vpadn*vpamo/ts-2/ctw**2*vpadn*vpamo/us)
     & +propiwqs*sdet3icmoqs*b0fmozmo*(-2/ctw**2*vpadn*vpamo)
     & +propiwqs*sdet3icmoqs*b0fqswz*mmo**2*(1d0/2/ctw**2*vpaup*vpamn/qs
     & +2/ctw**2*vpaup*vpamn/ts+2/ctw**2*vpaup*vpamn/us+1d0/2/ctw**2*vpa
     & dn*vpamo/qs+2/ctw**2*vpadn*vpamo/ts+2/ctw**2*vpadn*vpamo/us)
     & +propiwqs*sdet3icmoqs*b0fqswz*(3d0/2/ctw**2*vpaup*vpamn+3d0/2/ctw
     & **2*vpadn*vpamo)
     & +propiwqs*sdet3icmoqs*b0fqswc*mmo**2*(-2*ctw**2*qdn*qmo/qs-8*ctw*
     & *2*qdn*qmo/ts-8*ctw**2*qdn*qmo/us+2*qdn*qmo/qs+8*qdn*qmo/ts+8*qdn
     & *qmo/us)
     & +propiwqs*sdet3icmoqs*b0fqswc*(-6*ctw**2*qdn*qmo+6*qdn*qmo)
     & +propiwqs*sdet3icmoqs*b0fcwmo*mmo**2*(1d0/2/ctw**2*vpadn*vpamo/qs
     & -2*ctw**2*qdn*qmo/qs+2*qdn*qmo/qs)
     & +propiwqs*sdet3icmoqs*b0fcwmo*(1d0/2/ctw**2*vpadn*vpamo-2*ctw**2*
     & qdn*qmo+2*qdn*qmo)
     & +propiwqs*sdet3icmoqs*(8*ctw**2*qdn*qmo-8*qdn*qmo)
     & +propiwqs*sdet3icmots*mmo**2*(-2*ctw**2*qdn*qmo/us+2*qdn*qmo/us)
     & +propiwqs*sdet3icmots*c0moctsmozc*mmo**2*(1d0/2/ctw**4*vpadn*vpam
     & o/us*mw**2)
     & +propiwqs*sdet3icmots*c0moctscwc*mmo**2*(1d0/2/ctw**2*vpaup*vpamn
     & /us*mw**2)
     & +propiwqs*sdet3icmots*a0fmo*mmo**2*(-2*stw**2*qdn*qmo/us)
     & +propiwqs*sdet3icmots*b0fmowc*mmo**2*(1d0/2/ctw**2*vpaup*vpamn/us
     & )
     & +propiwqs*sdet3icmots*b0fmozmo*mmo**2*(1d0/2/ctw**2*vpadn*vpamo/u
     & s)
     & +propiwqs*sdet3icmots*b0ftsmoc*mmo**2*(-1d0/2/ctw**2*vpadn*vpamo/
     & us+2*ctw**2*qdn*qmo/us-2*qdn*qmo/us)
     & +propiwqs*sdet3icmots*b0ftscc*mmo**2*(-1d0/2/ctw**2*vpaup*vpamn/u
     & s)
     & +propiwqs*d0ccmocqstswczmo*mmo**2*(1d0/4/ctw**6*vpadn*vpamo/qs/us
     & *mw**4+1d0/4/ctw**6*vpadn*vpamo/us**2*mw**4-1d0/4/ctw**4*vpadn*vp
     & amo/qs/us*mw**4+1d0/4/ctw**4*vpadn*vpamo/qs*mw**2+1d0/2/ctw**4*vp
     & adn*vpamo*ts/us**2*mw**2+1d0/2/ctw**4*vpadn*vpamo/us*mw**2-1d0/4/
     & ctw**4*vpadn*vmamo/qs*mw**2-1d0/4/ctw**4*vpadn*vmamo/us*mw**2-1d0
     & /4/ctw**2*vpadn*vpamo/qs*mw**2+1d0/ctw**2*vpadn*vpamo*ts/us**2*mw
     & **2-1d0/4/ctw**2*vpadn*vpamo*ts/us-3d0/4/ctw**2*vpadn*vpamo*ts**2
     & /us**2-1d0/4/ctw**2*vpadn*vpamo/us**2*mw**4+1d0/4/ctw**2*vpadn*vp
     & amo/us*mw**2-1d0/4/ctw**2*vpadn*vpamo+1d0/4/ctw**2*vpadn*vmamo/qs
     & *mw**2+1d0/4/ctw**2*vpadn*vmamo*ts/us-1d0/4/ctw**2*vpadn*vmamo/us
     & *mw**2)
     & +propiwqs*d0ccmocqstswczmo*mmo**4*(1d0/4/ctw**6*vpadn*vpamo/qs/us
     & **2*mw**4+1d0/4/ctw**4*vpadn*vpamo/qs/us*mw**2-1d0/4/ctw**4*vpadn
     & *vmamo/qs/us*mw**2-3d0/4/ctw**2*vpadn*vpamo*ts/us**2+1d0/2/ctw**2
     & *vpadn*vpamo/us**2*mw**2-1d0/4/ctw**2*vpadn*vpamo/us+1d0/4/ctw**2
     & *vpadn*vmamo/us)
     & +propiwqs*d0ccmocqstswczmo*mmo**6*(-1d0/4/ctw**2*vpadn*vpamo/us**
     & 2)
     & +propiwqs*d0ccmocqstswczmo*(-1d0/4/ctw**6*vpadn*vpamo*ts/us**2*mw
     & **4-1d0/2/ctw**4*vpadn*vpamo*ts/us**2*mw**4+1d0/2/ctw**4*vpadn*vp
     & amo*ts**2/us**2*mw**2-1d0/2/ctw**4*vpadn*vpamo/us*mw**4-1d0/4/ctw
     & **2*vpadn*vpamo*ts/us**2*mw**4-1d0/4/ctw**2*vpadn*vpamo*ts+1d0/2/
     & ctw**2*vpadn*vpamo*ts**2/us**2*mw**2-1d0/4/ctw**2*vpadn*vpamo*ts*
     & *3/us**2)
     & +propiwqs*d0ccmocqstszcwc*mmo**2*(-1d0/4/ctw**6*vpaup*vpamn/us**2
     & *mw**4-1d0/4/ctw**4*vpaup*vpamn/qs/us*mw**4-1d0/4/ctw**4*vpaup*vp
     & amn/qs*mw**2+1d0/2/ctw**4*vpaup*vpamn*ts/us**2*mw**2+1d0/4/ctw**2
     & *vpaup*vpamn/qs/us*mw**4+1d0/4/ctw**2*vpaup*vpamn/qs*mw**2-1d0/4/
     & ctw**2*vpaup*vpamn*ts**2/us**2+1d0/4/ctw**2*vpaup*vpamn/us**2*mw*
     & *4+1d0/4/ctw**2*vpaup*vpamn/us*mw**2)
     & +propiwqs*d0ccmocqstszcwc*mmo**4*(1d0/4/ctw**2*vpaup*vpamn/qs/us*
     & *2*mw**4+1d0/4/ctw**2*vpaup*vpamn/qs/us*mw**2)
     & +propiwqs*d0ccmocqstszcwc*(-1d0/4/ctw**6*vpaup*vpamn*ts/us**2*mw*
     & *4-1d0/2/ctw**4*vpaup*vpamn*ts/us**2*mw**4+1d0/2/ctw**4*vpaup*vpa
     & mn*ts**2/us**2*mw**2-1d0/2/ctw**4*vpaup*vpamn/us*mw**4-1d0/4/ctw*
     & *2*vpaup*vpamn*ts/us**2*mw**4-1d0/4/ctw**2*vpaup*vpamn*ts+1d0/2/c
     & tw**2*vpaup*vpamn*ts**2/us**2*mw**2-1d0/4/ctw**2*vpaup*vpamn*ts**
     & 3/us**2)
     & +propiwqs*d0cccmoqsuswczc*(1d0/2/ctw**2*vpadn*vpamn*us)
     & +propiwqs*d0cccmoqsuszcwmo*mmo**2*(-1d0/4/ctw**4*vpaup*vmamo/qs*m
     & w**2+1d0/2/ctw**2*vpaup*vpamo+1d0/4/ctw**2*vpaup*vmamo/qs*mw**2+1
     & d0/4/ctw**2*vpaup*vmamo)
     & +propiwqs*d0cccmoqsuszcwmo*mmo**4*(1d0/4/ctw**2*vpaup*vmamo/qs/us
     & *mw**2+1d0/4/ctw**2*vpaup*vmamo/us)
     & +propiwqs*d0cccmoqsuszcwmo*(1d0/2/ctw**2*vpaup*vpamo*us)
     & +propiwqs*c0mocqswcz*mmo**2*(2/ctw**4*vpaup*vpamn/ts/us*mw**2+1d0
     & /4/ctw**2*vpaup*vpamn/us**2*mw**2+1d0/4/ctw**2*vpaup*vpamn/us)
     & +propiwqs*c0mocqswcz*mmo**4*(1d0/4/ctw**2*vpaup*vpamn/qs/us**2*mw
     & **2+1d0/4/ctw**2*vpaup*vpamn/qs/us)
     & +propiwqs*c0mocqswcz*(-1d0/ctw**4*vpaup*vpamn/qs*mw**2-1d0/4/ctw*
     & *4*vpaup*vpamn*ts/us**2*mw**2-1d0/4/ctw**4*vpaup*vpamn/us*mw**2+1
     & d0/2/ctw**2*vpaup*vpamn/qs*mw**2-1d0/4/ctw**2*vpaup*vpamn*ts/us**
     & 2*mw**2+1d0/4/ctw**2*vpaup*vpamn*ts**2/us**2-1d0/4/ctw**2*vpaup*v
     & pamn/us*mw**2+3d0/4/ctw**2*vpaup*vpamn-1d0/2/ctw**2*vpadn*vpamn)
     & +propiwqs*c0mocqszmow*mmo**2*(1d0/4/ctw**4*vpadn*vpamo/us**2*mw**
     & 2+1d0/4/ctw**2*vpaup*vmamo/us+2/ctw**2*vpadn*vpamo/ts/us*mw**2+1d
     & 0/4/ctw**2*vpadn*vpamo*ts/us**2+1d0/2/ctw**2*vpadn*vpamo/us-1d0/4
     & /ctw**2*vpadn*vmamo/us)
     & +propiwqs*c0mocqszmow*mmo**4*(1d0/4/ctw**4*vpadn*vpamo/qs/us**2*m
     & w**2+1d0/4/ctw**2*vpaup*vmamo/qs/us+1d0/4/ctw**2*vpadn*vpamo/qs/u
     & s-2/ctw**2*vpadn*vpamo/ts/us-1d0/4/ctw**2*vpadn*vmamo/qs/us)
     & +propiwqs*c0mocqszmow*(1d0/2/ctw**4*vpadn*vpamo/qs*mw**2-1d0/4/ct
     & w**4*vpadn*vpamo*ts/us**2*mw**2-1d0/4/ctw**4*vpadn*vpamo/us*mw**2
     & -1d0/2/ctw**2*vpaup*vpamo-1d0/ctw**2*vpadn*vpamo/qs*mw**2-1d0/4/c
     & tw**2*vpadn*vpamo*ts/us**2*mw**2+1d0/4/ctw**2*vpadn*vpamo*ts**2/u
     & s**2-1d0/4/ctw**2*vpadn*vpamo/us*mw**2+1d0/4/ctw**2*vpadn*vpamo)
     & +propiwqs*c0moctsmozc*mmo**2*(1d0/4/ctw**4*vpadn*vpamo/qs/us*mw**
     & 2+1d0/4/ctw**2*vpadn*vpamo/qs-1d0/2/ctw**2*vpadn*vpamo*ts/us**2+1
     & d0/4/ctw**2*vpadn*vpamo/us**2*mw**2-1d0/4/ctw**2*vpadn*vmamo/qs+1
     & d0/4/ctw**2*vpadn*vmamo/us)
     & +propiwqs*c0moctsmozc*mmo**4*(-1d0/4/ctw**2*vpadn*vpamo/us**2)
     & +propiwqs*c0moctsmozc*(1d0/4/ctw**4*vpadn*vpamo*ts/us**2*mw**2+1d
     & 0/4/ctw**2*vpadn*vpamo*ts/us**2*mw**2+1d0/4/ctw**2*vpadn*vpamo*ts
     & /us-1d0/4/ctw**2*vpadn*vpamo*ts**2/us**2)
     & +propiwqs*c0moctscwc*mmo**2*(1d0/4/ctw**4*vpaup*vpamn/us**2*mw**2
     & +1d0/4/ctw**2*vpaup*vpamn/qs/us*mw**2+1d0/4/ctw**2*vpaup*vpamn/qs
     & -1d0/4/ctw**2*vpaup*vpamn*ts/us**2)
     & +propiwqs*c0moctscwc*(1d0/4/ctw**4*vpaup*vpamn*ts/us**2*mw**2+1d0
     & /4/ctw**2*vpaup*vpamn*ts/us**2*mw**2+1d0/4/ctw**2*vpaup*vpamn*ts/
     & us-1d0/4/ctw**2*vpaup*vpamn*ts**2/us**2)
     & +propiwqs*c0mocusmozc*mmo**2*(-1d0/4/ctw**2*vpaup*vmamo/qs)
     & +propiwqs*c0mocusmozc*mmo**4*(-1d0/4/ctw**2*vpaup*vmamo/qs/us)
     & +propiwqs*c0ccqswcz*mmo**2*(-1d0/4/ctw**4*vpaup*vpamn/us**2*mw**2
     & +1d0/4/ctw**2*vpaup*vpamn*ts/us**2-1d0/4/ctw**2*vpaup*vmamo/us+1d
     & 0/2/ctw**2*vpadn*vpamo*ts/us**2-1d0/4/ctw**2*vpadn*vpamo/us**2*mw
     & **2+1d0/4/ctw**2*vpadn*vpamo/us-1d0/4/ctw**2*vpadn*vmamo/us)
     & +propiwqs*c0ccqswcz*mmo**4*(1d0/4/ctw**2*vpadn*vpamo/us**2)
     & +propiwqs*c0ccqswcz*(-1d0/4/ctw**4*vpaup*vpamn*ts/us**2*mw**2-1d0
     & /4/ctw**4*vpaup*vpamn/us*mw**2-1d0/4/ctw**4*vpadn*vpamo*ts/us**2*
     & mw**2-1d0/4/ctw**4*vpadn*vpamo/us*mw**2-1d0/4/ctw**2*vpaup*vpamn*
     & ts/us**2*mw**2+1d0/4/ctw**2*vpaup*vpamn*ts**2/us**2-1d0/4/ctw**2*
     & vpaup*vpamn/us*mw**2+1d0/4/ctw**2*vpaup*vpamn-1d0/2/ctw**2*vpaup*
     & vpamo-1d0/2/ctw**2*vpadn*vpamn-1d0/4/ctw**2*vpadn*vpamo*ts/us**2*
     & mw**2+1d0/4/ctw**2*vpadn*vpamo*ts**2/us**2-1d0/4/ctw**2*vpadn*vpa
     & mo/us*mw**2+1d0/4/ctw**2*vpadn*vpamo)
     & +propiwqs*c0cctscwmo*mmo**2*(-1d0/4/ctw**4*vpadn*vpamo/qs/us*mw**
     & 2-1d0/4/ctw**4*vpadn*vpamo/us**2*mw**2-1d0/4/ctw**2*vpadn*vpamo/q
     & s-1d0/4/ctw**2*vpadn*vpamo*ts/us**2-1d0/4/ctw**2*vpadn*vpamo/us+1
     & d0/4/ctw**2*vpadn*vmamo/qs+1d0/4/ctw**2*vpadn*vmamo/us+ctw**2*qdn
     & *qmo*ts/us**2-qdn*qmo*ts/us**2)
     & +propiwqs*c0cctscwmo*mmo**4*(-1d0/4/ctw**4*vpadn*vpamo/qs/us**2*m
     & w**2-1d0/4/ctw**2*vpadn*vpamo/qs/us+1d0/4/ctw**2*vpadn*vmamo/qs/u
     & s)
     & +propiwqs*c0cctscwmo*(1d0/4/ctw**4*vpadn*vpamo*ts/us**2*mw**2+1d0
     & /4/ctw**2*vpadn*vpamo*ts/us**2*mw**2+1d0/4/ctw**2*vpadn*vpamo*ts/
     & us-1d0/4/ctw**2*vpadn*vpamo*ts**2/us**2-ctw**2*qdn*qmo*ts/us**2*m
     & w**2-ctw**2*qdn*qmo*ts/us+ctw**2*qdn*qmo*ts**2/us**2+qdn*qmo*ts/u
     & s**2*mw**2+qdn*qmo*ts/us-qdn*qmo*ts**2/us**2)
     & +propiwqs*c0cctsczc*mmo**2*(-1d0/4/ctw**2*vpaup*vpamn/qs/us*mw**2
     & -1d0/4/ctw**2*vpaup*vpamn/qs-1d0/4/ctw**2*vpaup*vpamn/us**2*mw**2
     & -1d0/4/ctw**2*vpaup*vpamn/us)
     & +propiwqs*c0cctsczc*mmo**4*(-1d0/4/ctw**2*vpaup*vpamn/qs/us**2*mw
     & **2-1d0/4/ctw**2*vpaup*vpamn/qs/us)
     & +propiwqs*c0cctsczc*(1d0/4/ctw**4*vpaup*vpamn*ts/us**2*mw**2+1d0/
     & 4/ctw**2*vpaup*vpamn*ts/us**2*mw**2+1d0/4/ctw**2*vpaup*vpamn*ts/u
     & s-1d0/4/ctw**2*vpaup*vpamn*ts**2/us**2)
     & +propiwqs*c0ccuscwmo*mmo**2*(1d0/4/ctw**2*vpaup*vmamo/qs-ctw**2*q
     & up*qmo/qs+qup*qmo/qs)
     & +propiwqs*a0fw*(3/qs*mw**2/mh**2-4/qs)
     & +propiwqs*a0fz*(3d0/2/ctw**4/qs*mw**2/mh**2+1d0/2/ctw**2*vpaup*vp
     & amn/qs)
     & +propiwqs*a0fmo*mmo**2*(8*stw**2*qdn*qmo/ts/us)
     & +propiwqs*b0fmowc*mmo**2*(-2/ctw**2*vpaup*vpamn/ts/us)
     & +propiwqs*b0fmowc*(1d0/ctw**2*vpaup*vpamn/qs)
     & +propiwqs*b0fmozmo*mmo**2*(-2/ctw**2*vpadn*vpamo/ts/us)
     & +propiwqs*b0fmozmo*(1d0/ctw**2*vpadn*vpamo/qs)
     & +propiwqs*b0fqswz*mmo**2*(2/ctw**2*vpaup*vpamn/ts/us+2/ctw**2*vpa
     & dn*vpamo/ts/us)
     & +propiwqs*b0fqswz*(-1d0/2/ctw**2*vpaup*vpamn/qs-1d0/2/ctw**2*vpau
     & p*vpamn/us-1d0/2/ctw**2*vpadn*vpamo/qs-1d0/2/ctw**2*vpadn*vpamo/u
     & s+5d0/6/ctw**2/qs-14d0/3*ctw**2/qs-53d0/12/qs)
     & +propiwqs*b0fqswh*(11d0/12/qs)
     & +propiwqs*b0fqswc*mmo**2*(-8*ctw**2*qdn*qmo/ts/us+8*qdn*qmo/ts/us
     & )
     & +propiwqs*b0fqswc*(2*ctw**2*qdn*qmo/qs+2*ctw**2*qdn*qmo/us+14d0/3
     & *ctw**2/qs-2*qdn*qmo/qs-2*qdn*qmo/us-14d0/3/qs)
     & +propiwqs*b0ftsmoc*(1d0/2/ctw**2*vpadn*vpamo/us-2*ctw**2*qdn*qmo/
     & us+2*qdn*qmo/us)
     & +propiwqs*b0ftscc*(1d0/2/ctw**2*vpaup*vpamn/us)
     & +propiwqs*b0fcwmo*(-1d0/2/ctw**2*vpadn*vpamo/qs+2*ctw**2*qdn*qmo/
     & qs-2*qdn*qmo/qs)
     & +propiwqs*(1d0/ctw**4/qs*mw**2/mh**2-1d0/6/ctw**2/qs-4*ctw**2*qdn
     & *qmo/qs+4*qdn*qmo/qs+2/qs*mw**2/mh**2-64d0/9/qs)
     & +sdet3icmoqs**2*mmo**2*(2*ctw**2*qmo*mw**2-2*qmo*mw**2)
     & +sdet3icmoqs**2*mmo**4*(-2*ctw**2*qmo+2*qmo)
     & +sdet3icmoqs**2*c0mocqswcz*mmo**2*(-1d0/ctw**4*vpamn*mw**4)
     & +sdet3icmoqs**2*c0mocqszmow*mmo**2*(vpamo*mw**4)
     & +sdet3icmoqs**2*c0mocqszmow*mmo**4*(-7d0/4*vpamo*mw**2-1d0/4*vmam
     & o*mw**2)
     & +sdet3icmoqs**2*c0mocqszmow*mmo**6*(1d0/2*vpamo+1d0/2*vmamo)
     & +sdet3icmoqs**2*c0mocqszmow*mmo**8*(1d0/4*vpamo/mw**2-1d0/4*vmamo
     & /mw**2)
     & +sdet3icmoqs**2*c0mocqshmow*mmo**4*(-1d0/4*mw**2)
     & +sdet3icmoqs**2*c0mocqshmow*mmo**6*(1d0/2)
     & +sdet3icmoqs**2*c0mocqshmow*mmo**8*(-1d0/4/mw**2)
     & +sdet3icmoqs**2*c0mocqsmozc*mmo**2*(1d0/2/ctw**6*vpamn*vpamo*mw**
     & 4)
     & +sdet3icmoqs**2*c0mocqscmow*mmo**2*(-2*stw**2*mw**4)
     & +sdet3icmoqs**2*c0mocqscmow*mmo**4*(4*stw**2*mw**2)
     & +sdet3icmoqs**2*c0mocqscmow*mmo**6*(-2*stw**2)
     & +sdet3icmoqs**2*a0fmo*mmo**2*(2*stw**2*qmo*mw**2)
     & +sdet3icmoqs**2*a0fmo*mmo**4*(-2*stw**2*qmo)
     & +sdet3icmoqs**2*b0fmowc*mmo**2*(1d0/ctw**2*vpamn*mw**2)
     & +sdet3icmoqs**2*b0fmozmo*mmo**2*(1d0/2/ctw**4*vpamn*vpamo*mw**2-v
     & pamo*mw**2)
     & +sdet3icmoqs**2*b0fmozmo*mmo**4*(3d0/4*vpamo+1d0/4*vmamo)
     & +sdet3icmoqs**2*b0fmozmo*mmo**6*(1d0/4*vpamo/mw**2-1d0/4*vmamo/mw
     & **2)
     & +sdet3icmoqs**2*b0fmohmo*mmo**4*(1d0/4)
     & +sdet3icmoqs**2*b0fmohmo*mmo**6*(-1d0/4/mw**2)
     & +sdet3icmoqs**2*b0fqswz*mmo**2*(-1d0/ctw**2*vpamn*mw**2+vpamo*mw*
     & *2)
     & +sdet3icmoqs**2*b0fqswz*mmo**4*(-3d0/4*vpamo-1d0/4*vmamo)
     & +sdet3icmoqs**2*b0fqswz*mmo**6*(-1d0/4*vpamo/mw**2+1d0/4*vmamo/mw
     & **2)
     & +sdet3icmoqs**2*b0fqswh*mmo**4*(-1d0/4)
     & +sdet3icmoqs**2*b0fqswh*mmo**6*(1d0/4/mw**2)
     & +sdet3icmoqs**2*b0fqswc*mmo**2*(-2*ctw**2*qmo*mw**2+2*qmo*mw**2)
     & +sdet3icmoqs**2*b0fqswc*mmo**4*(2*ctw**2*qmo-2*qmo)
     & +sdet3icmoqs**2*b0fqsmoc*mmo**2*(-1d0/2/ctw**4*vpamn*vpamo*mw**2)
     & +sdet3icmoqs*c0mocqswcz*mmo**2*(1d0/2/ctw**4*vpamn*mw**2)
     & +sdet3icmoqs*c0mocqswcz*(1d0/ctw**2*vpamn*mw**4)
     & +sdet3icmoqs*c0mocqszmow*mmo**2*(3d0/4/ctw**2*vpamo*mw**2-1d0/4/c
     & tw**2*vmamo*mw**2+1d0/2*vpamo*mw**2+1d0/2*vmamo*mw**2)
     & +sdet3icmoqs*c0mocqszmow*mmo**4*(1d0/4/ctw**2*vpamo+1d0/4/ctw**2*
     & vmamo-vmamo)
     & +sdet3icmoqs*c0mocqszmow*mmo**6*(-1d0/2*vpamo/mw**2+1d0/2*vmamo/m
     & w**2)
     & +sdet3icmoqs*c0mocqszmow*(-1d0/ctw**2*vpamo*mw**4)
     & +sdet3icmoqs*c0mocqshmow*mmo**2*(-1d0/2*mw**2+1d0/4*mh**2)
     & +sdet3icmoqs*c0mocqshmow*mmo**4*(-1d0/4/mw**2*mh**2)
     & +sdet3icmoqs*c0mocqshmow*mmo**6*(1d0/2/mw**2)
     & +sdet3icmoqs*c0mocqsmozc*mmo**2*(-1d0/2/ctw**4*vpamn*vpamo*mw**2)
     & +sdet3icmoqs*c0mocqsmozc*(-1d0/2/ctw**6*vpamn*vpamo*mw**4)
     & +sdet3icmoqs*c0mocqscmow*mmo**2*(-4*stw**2*qdn/qs*mw**4-8*stw**2*
     & qdn/ts*mw**4-8*stw**2*qdn/us*mw**4-2*stw**2*mw**2)
     & +sdet3icmoqs*c0mocqscmow*mmo**4*(16*stw**2*qdn/ts*mw**2+16*stw**2
     & *qdn/us*mw**2+2*stw**2)
     & +sdet3icmoqs*c0mocqscmow*mmo**6*(-8*stw**2*qdn/ts-8*stw**2*qdn/us
     & )
     & +sdet3icmoqs*c0mocqscmow*(-4*stw**2*qdn*mw**4)
     & +sdet3icmoqs*a0fw*mmo**2*(1d0/8-1d0/8*vpamo+1d0/8*vmamo)
     & +sdet3icmoqs*a0fw*(ctw**2*qmo*mw**2-qmo*mw**2-1d0/2*vpamo*mw**2)
     & +sdet3icmoqs*a0fz*(1d0/4/ctw**4*vpamn*vpamo*mw**2+1d0/2/ctw**2*vp
     & amn*mw**2)
     & +sdet3icmoqs*a0fmo*mmo**2*(stw**2*qmo+1d0/2*vpamo)
     & +sdet3icmoqs*a0fmo*mmo**4*(1d0/8*vpamo/mw**2-1d0/8*vmamo/mw**2-1d
     & 0/8/mw**2)
     & +sdet3icmoqs*b0fmowc*mmo**2*(-1d0/2/ctw**2*vpamn-1d0/2*vpamn)
     & +sdet3icmoqs*b0fmowc*(-1d0/2*vpamn*mw**2)
     & +sdet3icmoqs*b0fmozmo*mmo**2*(-1d0/2/ctw**2*vpamn*vpamo+1d0/8/ctw
     & **2*vpamo+3d0/8/ctw**2*vmamo+1d0/2*vpamo-1d0/2*vmamo)
     & +sdet3icmoqs*b0fmozmo*mmo**4*(-1d0/4*vpamo/mw**2+1d0/4*vmamo/mw**
     & 2)
     & +sdet3icmoqs*b0fmozmo*(-1d0/4/ctw**4*vpamn*vpamo*mw**2+1d0/2/ctw*
     & *2*vpamo*mw**2)
     & +sdet3icmoqs*b0fmohmo*mmo**2*(1d0/2-1d0/8/mw**2*mh**2)
     & +sdet3icmoqs*b0fmohmo*mmo**4*(1d0/4/mw**2)
     & +sdet3icmoqs*b0fqswz*mmo**2*(1d0/2/ctw**2*vpamn-1d0/8/ctw**2*vpam
     & o-3d0/8/ctw**2*vmamo+1d0/2*vpamn-1d0/8*vpamo+5d0/8*vmamo)
     & +sdet3icmoqs*b0fqswz*mmo**4*(3d0/8*vpamo/mw**2-3d0/8*vmamo/mw**2)
     & +sdet3icmoqs*b0fqswz*(1d0/2/ctw**2*vpamn*mw**2-1d0/2/ctw**2*vpamo
     & *mw**2+1d0/2*vpamn*mw**2-1d0/2*vpamo*mw**2)
     & +sdet3icmoqs*b0fqswh*mmo**2*(-3d0/8+1d0/8/mw**2*mh**2)
     & +sdet3icmoqs*b0fqswh*mmo**4*(-3d0/8/mw**2)
     & +sdet3icmoqs*b0fqswc*mmo**2*(-ctw**2*qmo+qmo)
     & +sdet3icmoqs*b0fqswc*(ctw**2*qmo*mw**2-qmo*mw**2)
     & +sdet3icmoqs*b0fqsmoc*mmo**2*(1d0/2/ctw**2*vpamn*vpamo)
     & +sdet3icmoqs*b0fqsmoc*(1d0/2/ctw**4*vpamn*vpamo*mw**2)
     & +sdet3icmous*c0mocqscmow*mmo**2*(stw**2*qdn*ts-stw**2*qdn*mw**2+s
     & tw**2*ts-stw**2*mw**2)
     & +sdet3icmous*c0mocqscmow*mmo**4*(-stw**2*qdn/qs*mw**2+stw**2*qdn*
     & ts/us-stw**2*qdn/us*mw**2-stw**2/qs*mw**2+stw**2*ts/us-stw**2/us*
     & mw**2)
     & +sdet3icmous*c0mocqscmow*mmo**6*(-stw**2*qdn/qs/us*mw**2-stw**2/q
     & s/us*mw**2)
     & +javsubqstscmow*mmo**2*(4*ctw**2*qdn*qmo*ts/us**2*mw**2-3*ctw**2*
     & qdn*qmo*ts**2/us**2-ctw**2*qdn*qmo/us**2*mw**4-ctw**2*qdn*qmo-4*q
     & dn*qmo*ts/us**2*mw**2+3*qdn*qmo*ts**2/us**2+qdn*qmo/us**2*mw**4+q
     & dn*qmo)
     & +javsubqstscmow*mmo**4*(-3*ctw**2*qdn*qmo*ts/us**2+2*ctw**2*qdn*q
     & mo/us**2*mw**2+3*qdn*qmo*ts/us**2-2*qdn*qmo/us**2*mw**2)
     & +javsubqstscmow*mmo**6*(-ctw**2*qdn*qmo/us**2+qdn*qmo/us**2)
     & +javsubqstscmow*(-ctw**2*qdn*qmo*ts/us**2*mw**4-ctw**2*qdn*qmo*ts
     & +2*ctw**2*qdn*qmo*ts**2/us**2*mw**2-ctw**2*qdn*qmo*ts**3/us**2+qd
     & n*qmo*ts/us**2*mw**4+qdn*qmo*ts-2*qdn*qmo*ts**2/us**2*mw**2+qdn*q
     & mo*ts**3/us**2)
     & +javsubqsuscmow*mmo**2*(ctw**2*qup*qmo/qs*mw**2+3*ctw**2*qup*qmo-
     & qup*qmo/qs*mw**2-3*qup*qmo)
     & +javsubqsuscmow*mmo**4*(ctw**2*qup*qmo/qs/us*mw**2+ctw**2*qup*qmo
     & /us-qup*qmo/qs/us*mw**2-qup*qmo/us)
     & +javsubqsuscmow*(2*ctw**2*qup*qmo*us-2*qup*qmo*us)
     & +c0mocqswcz*mmo**2*(vpamn)
     & +c0mocqswcz*(-1d0/ctw**2*vpamn*mw**2-vpamn*mw**2)
     & +c0mocqszmow*mmo**2*(-1d0/2/ctw**2*vpamo-1d0/2*vpamo+3d0/2*vmamo)
     & +c0mocqszmow*mmo**4*(1d0/4*vpamo/mw**2-1d0/4*vmamo/mw**2)
     & +c0mocqszmow*(1d0/ctw**2*vpamo*mw**2+vpamo*mw**2)
     & +c0mocqshmow*mmo**2*(1d0/2)
     & +c0mocqshmow*mmo**4*(-1d0/4/mw**2)
     & +c0mocqsmozc*(1d0/ctw**4*vpamn*vpamo*mw**2+1d0/2/ctw**2*vpamn*vpa
     & mo*ts+1d0/2/ctw**2*vpamn*vpamo*us)
     & +c0mocqscmow*mmo**2*(-8*stw**2*qdn/ts/us*mw**4+stw**2*qdn*ts/us-s
     & tw**2*qdn/us*mw**2+2*stw**2*qdn+stw**2*ts/us-stw**2/us*mw**2-2*st
     & w**2)
     & +c0mocqscmow*mmo**4*(-stw**2*qdn/qs/us*mw**2+16*stw**2*qdn/ts/us*
     & mw**2-stw**2/qs/us*mw**2)
     & +c0mocqscmow*mmo**6*(-8*stw**2*qdn/ts/us)
     & +c0mocqscmow*(4*stw**2*qdn/qs*mw**4)
     & +c0ccqswcz*(1d0/ctw**2*vpaup/qs*mw**4-1d0/ctw**2*vpaup*mw**2-1d0/
     & ctw**2*vpadn/qs*mw**4+1d0/ctw**2*vpadn*mw**2-vpaup*mw**2+vpadn*mw
     & **2)
     & +c0ccqsczc*mmo**2*(1d0/2/ctw**2*vpaup*vpadn)
     & +c0ccqsczc*(-1d0/2/ctw**6*vpaup*vpadn/qs*mw**4+1d0/ctw**4*vpaup*v
     & padn*mw**2+1d0/2/ctw**2*vpaup*vpadn*ts+1d0/2/ctw**2*vpaup*vpadn*u
     & s)
     & +c0cctscwmo*mmo**2*(4*ctw**2*qdn*qmo*ts/us**2*mw**2-3*ctw**2*qdn*
     & qmo*ts**2/us**2-ctw**2*qdn*qmo/us**2*mw**4-ctw**2*qdn*qmo-4*qdn*q
     & mo*ts/us**2*mw**2+3*qdn*qmo*ts**2/us**2+qdn*qmo/us**2*mw**4+qdn*q
     & mo)
     & +c0cctscwmo*mmo**4*(-3*ctw**2*qdn*qmo*ts/us**2+2*ctw**2*qdn*qmo/u
     & s**2*mw**2+3*qdn*qmo*ts/us**2-2*qdn*qmo/us**2*mw**2)
     & +c0cctscwmo*mmo**6*(-ctw**2*qdn*qmo/us**2+qdn*qmo/us**2)
     & +c0cctscwmo*(-ctw**2*qdn*qmo*ts/us**2*mw**4-ctw**2*qdn*qmo*ts+2*c
     & tw**2*qdn*qmo*ts**2/us**2*mw**2-ctw**2*qdn*qmo*ts**3/us**2+qdn*qm
     & o*ts/us**2*mw**4+qdn*qmo*ts-2*qdn*qmo*ts**2/us**2*mw**2+qdn*qmo*t
     & s**3/us**2)
     & +c0ccuscwmo*mmo**2*(ctw**2*qup*qmo/qs*mw**2+3*ctw**2*qup*qmo-qup*
     & qmo/qs*mw**2-3*qup*qmo)
     & +c0ccuscwmo*mmo**4*(ctw**2*qup*qmo/qs/us*mw**2+ctw**2*qup*qmo/us-
     & qup*qmo/qs/us*mw**2-qup*qmo/us)
     & +c0ccuscwmo*(2*ctw**2*qup*qmo*us-2*qup*qmo*us)
     & +a0fw*(65d0/8+1d0/12/ctw**2/qs*mw**2-ctw**2*qup/qs*mw**2+2*ctw**2
     & *qup+ctw**2*qdn/qs*mw**2-2*ctw**2*qdn+qup/qs*mw**2-2*qup-qdn/qs*m
     & w**2+2*qdn+1d0/2*vpaup/qs*mw**2-vpaup-1d0/2*vpadn/qs*mw**2+vpadn+
     & 23d0/6/qs*mw**2-3/qs*mw**4/mh**2+1d0/12/qs*mh**2-3*mw**2/mh**2+7d
     & 0/8*invfmow-2*invfmow*ctw**2*qmo+2*invfmow*qmo+invfmow*vpamo-3d0/
     & 8*invfmow**2)
     & +a0fz*(1d0/2/ctw**4*vpaup*vpadn/qs*mw**2-1d0/12/ctw**4/qs*mw**2-3
     & d0/2/ctw**4/qs*mw**4/mh**2-3d0/2/ctw**4*mw**2/mh**2-1d0/ctw**2*vp
     & aup*vpadn+1d0/2/ctw**2*vpaup/qs*mw**2+1d0/8/ctw**2*vpaup**2-1d0/2
     & /ctw**2*vpadn/qs*mw**2+1d0/8/ctw**2*vpadn**2-1d0/2/ctw**2*vpamn*v
     & pamo+1d0/8/ctw**2*vpamn**2+1d0/8/ctw**2*vpamo*vmamo-1d0/16/ctw**2
     & *vpamo**2+1d0/16/ctw**2*vmamo**2-7d0/12/ctw**2/qs*mw**2-vpaup+vpa
     & dn-vpamn+2d0/3/qs*mw**2)
     & +a0fh*(1d0/12/qs*mh**2-1d0/16/mw**2*mh**2)
     & +a0fmo*mmo**2*(1d0/4*stw**4*qmo**2/mw**2-1d0/8*vpamo*vmamo/mw**2+
     & 1d0/16*vpamo**2/mw**2+3d0/16/mw**2-2*invfmow*stw**2*qmo/mw**2-inv
     & fmow*vpamo/mw**2-7d0/8*invfmow/mw**2+3d0/8*invfmow**2/mw**2)
     & +a0fmo*(-3d0/8+3d0/8*invfmow)
     & +b0fmowc*(-3d0/8+vpamn)
     & +b0fmozmo*(1d0/2/ctw**2*vpamn*vpamo+1d0/8/ctw**2*vpamo*vmamo-3d0/
     & 16/ctw**2*vpamo**2+1d0/16/ctw**2*vmamo**2-vpamo)
     & +b0fmohmo*(-1d0/16/mw**2*mh**2)
     & +b0fqswz*mmo**2*(-1d0/8*vpamo/mw**2+1d0/8*vmamo/mw**2)
     & +b0fqswz*(13d0/3-1d0/12/ctw**4/qs*mw**2+1d0/2/ctw**2*vpaup/qs*mw*
     & *2-1d0/2/ctw**2*vpadn/qs*mw**2-4d0/3/ctw**2/qs*mw**2-5d0/6/ctw**2
     & +4*ctw**2/qs*mw**2+8*ctw**2+1d0/2*vpaup/qs*mw**2-1d0/2*vpaup-1d0/
     & 2*vpadn/qs*mw**2+1d0/2*vpadn-1d0/2*vpamn+1d0/2*vpamo+17d0/3/qs*mw
     & **2)
     & +b0fqswh*mmo**2*(1d0/8/mw**2)
     & +b0fqswh*(-1-1d0/qs*mw**2+1d0/6/qs*mh**2)
     & +b0fqswc*(8-ctw**2*qup/qs*mw**2+ctw**2*qup+ctw**2*qdn/qs*mw**2-ct
     & w**2*qdn-ctw**2*qmo-4*ctw**2/qs*mw**2-8*ctw**2+qup/qs*mw**2-qup-q
     & dn/qs*mw**2+qdn+qmo+4/qs*mw**2)
     & +b0fqsmoc*(-3d0/4/ctw**2*vpamn*vpamo)
     & +b0fqscc*(1d0/2/ctw**4*vpaup*vpadn/qs*mw**2-3d0/4/ctw**2*vpaup*vp
     & adn+3*ctw**2*qup*qdn-3*qup*qdn)
     & +dreal(b0pmozmo)*mmo**2*(-3d0/4/ctw**2*vpamo*vmamo+1d0/8/ctw**2*v
     & pamo**2+1d0/8/ctw**2*vmamo**2)
     & +dreal(b0pmozmo)*(-1d0/8/ctw**4*vpamo**2*mw**2-1d0/8/ctw**4*vmamo
     & **2*mw**2)
     & +dreal(b0pmohmo)*mmo**2*(-1d0/8/mw**2*mh**2)
     & +dreal(b0pmohmo)*mmo**4*(1d0/2/mw**2)
     & +dreal(b0pmocw)*mmo**2*(1d0/8)
     & +dreal(b0pmocw)*mmo**4*(1d0/8/mw**2)
     & +dreal(b0pmocw)*(-1d0/4*mw**2)
     & +110d0/9+1d0/stw**2*ctw**2*deltarhobos+1d0/stw**2*ctw**2*deltarho
     & fer-1d0/ctw**4/qs*mw**4/mh**2-1d0/ctw**4*mw**2/mh**2-1d0/2/ctw**2
     & *vpaup*vpadn+3d0/16/ctw**2*vpaup**2+3d0/16/ctw**2*vpadn**2-1d0/2/
     & ctw**2*vpamn*vpamo+3d0/16/ctw**2*vpamn**2+1d0/8/ctw**2*vpamo**2-1
     & d0/16/ctw**2*vmamo**2+1d0/6/ctw**2/qs*mw**2+1d0/6/ctw**2-2*ctw**2
     & *qup*qdn-2*ctw**2*qup+3d0/2*ctw**2*qup**2+2*ctw**2*qdn+3d0/2*ctw*
     & *2*qdn**2+2*ctw**2*qmo+3d0/2*ctw**2*qmo**2+2*qup*qdn+2*qup-3d0/2*
     & qup**2-2*qdn-3d0/2*qdn**2-2*qmo-3d0/2*qmo**2+64d0/9/qs*mw**2-2/qs
     & *mw**4/mh**2-2*mw**2/mh**2-za1bos-za1fer+caldwfer+3d0/8*invfmow

      ff_ew_ld =
     & +propiwqs*mmo*(ctw**2*qdn*qmo/ts/us-qdn*qmo/ts/us)
     & +propiwqs*sdet3icmoqs*mmo*(ctw**2*qdn*qmo/ts-ctw**2*qdn*qmo/us-qd
     & n*qmo/ts+qdn*qmo/us)
     & +propiwqs*sdet3icmoqs*c0mocqswcz*mmo*(1d0/4/ctw**4*vpaup*vpamn/ts
     & *mw**2-1d0/4/ctw**4*vpaup*vpamn/us*mw**2)
     & +propiwqs*sdet3icmoqs*c0mocqszmow*mmo*(1d0/4/ctw**2*vpadn*vpamo/t
     & s*mw**2-1d0/4/ctw**2*vpadn*vpamo/us*mw**2)
     & +propiwqs*sdet3icmoqs*c0mocqszmow*mmo**3*(-1d0/4/ctw**2*vpadn*vpa
     & mo/ts+1d0/4/ctw**2*vpadn*vpamo/us)
     & +propiwqs*sdet3icmoqs*a0fmo*mmo*(stw**2*qdn*qmo/ts-stw**2*qdn*qmo
     & /us)
     & +propiwqs*sdet3icmoqs*b0fmowc*mmo*(-1d0/4/ctw**2*vpaup*vpamn/ts+1
     & d0/4/ctw**2*vpaup*vpamn/us)
     & +propiwqs*sdet3icmoqs*b0fmozmo*mmo*(-1d0/4/ctw**2*vpadn*vpamo/ts+
     & 1d0/4/ctw**2*vpadn*vpamo/us)
     & +propiwqs*sdet3icmoqs*b0fqswz*mmo*(1d0/4/ctw**2*vpaup*vpamn/ts-1d
     & 0/4/ctw**2*vpaup*vpamn/us+1d0/4/ctw**2*vpadn*vpamo/ts-1d0/4/ctw**
     & 2*vpadn*vpamo/us)
     & +propiwqs*sdet3icmoqs*b0fqswc*mmo*(-ctw**2*qdn*qmo/ts+ctw**2*qdn*
     & qmo/us+qdn*qmo/ts-qdn*qmo/us)
     & +propiwqs*sdet3icmots*mmo*(-2*ctw**2*qdn*qmo/us+2*qdn*qmo/us)
     & +propiwqs*sdet3icmots*c0moctsmozc*mmo*(1d0/2/ctw**4*vpadn*vpamo/u
     & s*mw**2)
     & +propiwqs*sdet3icmots*c0moctscwc*mmo*(1d0/2/ctw**2*vpaup*vpamn/us
     & *mw**2)
     & +propiwqs*sdet3icmots*a0fmo*mmo*(-2*stw**2*qdn*qmo/us)
     & +propiwqs*sdet3icmots*b0fmowc*mmo*(1d0/2/ctw**2*vpaup*vpamn/us)
     & +propiwqs*sdet3icmots*b0fmozmo*mmo*(1d0/2/ctw**2*vpadn*vpamo/us)
     & +propiwqs*sdet3icmots*b0ftsmoc*mmo*(-1d0/2/ctw**2*vpadn*vpamo/us+
     & 2*ctw**2*qdn*qmo/us-2*qdn*qmo/us)
     & +propiwqs*sdet3icmots*b0ftscc*mmo*(-1d0/2/ctw**2*vpaup*vpamn/us)
     & +propiwqs*d0ccmocqstswczmo*mmo*(1d0/4/ctw**6*vpadn*vpamo/qs/us*mw
     & **4+1d0/4/ctw**6*vpadn*vpamo/us**2*mw**4-1d0/4/ctw**4*vpadn*vpamo
     & /qs/us*mw**4+1d0/4/ctw**4*vpadn*vpamo/qs*mw**2-1d0/2/ctw**4*vpadn
     & *vpamo*ts/us**2*mw**2+1d0/2/ctw**4*vpadn*vpamo/us**2*mw**4+1d0/4/
     & ctw**4*vpadn*vpamo/us*mw**2-1d0/4/ctw**4*vpadn*vmamo/qs*mw**2-1d0
     & /4/ctw**4*vpadn*vmamo/us*mw**2-1d0/4/ctw**2*vpadn*vpamo/qs*mw**2-
     & 1d0/2/ctw**2*vpadn*vpamo*ts/us**2*mw**2+1d0/4/ctw**2*vpadn*vpamo*
     & ts**2/us**2+1d0/4/ctw**2*vpadn*vpamo/us**2*mw**4+1d0/4/ctw**2*vpa
     & dn*vmamo/qs*mw**2+1d0/4/ctw**2*vpadn*vmamo*ts/us-1d0/4/ctw**2*vpa
     & dn*vmamo/us*mw**2)
     & +propiwqs*d0ccmocqstswczmo*mmo**3*(1d0/4/ctw**6*vpadn*vpamo/qs/us
     & **2*mw**4+1d0/4/ctw**4*vpadn*vpamo/qs/us*mw**2-1d0/2/ctw**4*vpadn
     & *vpamo/us**2*mw**2-1d0/4/ctw**4*vpadn*vmamo/qs/us*mw**2+1d0/4/ctw
     & **2*vpadn*vpamo/ts/us**2*mw**4-1d0/4/ctw**2*vpadn*vpamo/ts/us*mw*
     & *2+3d0/4/ctw**2*vpadn*vpamo*ts/us**2-1d0/ctw**2*vpadn*vpamo/us**2
     & *mw**2+1d0/4/ctw**2*vpadn*vpamo/us+1d0/4/ctw**2*vpadn*vmamo/us)
     & +propiwqs*d0ccmocqstswczmo*mmo**5*(-1d0/2/ctw**2*vpadn*vpamo/ts/u
     & s**2*mw**2+1d0/4/ctw**2*vpadn*vpamo/ts/us+3d0/4/ctw**2*vpadn*vpam
     & o/us**2)
     & +propiwqs*d0ccmocqstswczmo*mmo**7*(1d0/4/ctw**2*vpadn*vpamo/ts/us
     & **2)
     & +propiwqs*d0ccmocqstszcwc*mmo*(1d0/4/ctw**6*vpaup*vpamn/us**2*mw*
     & *4-1d0/4/ctw**4*vpaup*vpamn/qs/us*mw**4-1d0/4/ctw**4*vpaup*vpamn/
     & qs*mw**2-1d0/2/ctw**4*vpaup*vpamn*ts/us**2*mw**2+1d0/2/ctw**4*vpa
     & up*vpamn/us**2*mw**4+1d0/4/ctw**2*vpaup*vpamn/qs/us*mw**4+1d0/4/c
     & tw**2*vpaup*vpamn/qs*mw**2-1d0/2/ctw**2*vpaup*vpamn*ts/us**2*mw**
     & 2+1d0/4/ctw**2*vpaup*vpamn*ts**2/us**2+1d0/4/ctw**2*vpaup*vpamn/u
     & s**2*mw**4+1d0/4/ctw**2*vpaup*vpamn/us*mw**2)
     & +propiwqs*d0ccmocqstszcwc*mmo**3*(1d0/4/ctw**6*vpaup*vpamn/ts/us*
     & *2*mw**4-1d0/2/ctw**4*vpaup*vpamn/us**2*mw**2+1d0/4/ctw**2*vpaup*
     & vpamn/qs/us**2*mw**4+1d0/4/ctw**2*vpaup*vpamn/qs/us*mw**2+1d0/4/c
     & tw**2*vpaup*vpamn*ts/us**2)
     & +propiwqs*d0cccmoqsuszcwmo*mmo*(-1d0/4/ctw**4*vpaup*vmamo/qs*mw**
     & 2+1d0/4/ctw**4*vpaup*vmamo/ts*mw**2+1d0/4/ctw**2*vpaup*vmamo/qs*m
     & w**2-1d0/4/ctw**2*vpaup*vmamo/ts*us+1d0/4/ctw**2*vpaup*vmamo/ts*m
     & w**2)
     & +propiwqs*d0cccmoqsuszcwmo*mmo**3*(1d0/4/ctw**2*vpaup*vmamo/qs/us
     & *mw**2+1d0/4/ctw**2*vpaup*vmamo/ts/us*mw**2-1d0/2/ctw**2*vpaup*vm
     & amo/ts)
     & +propiwqs*d0cccmoqsuszcwmo*mmo**5*(-1d0/4/ctw**2*vpaup*vmamo/ts/u
     & s)
     & +propiwqs*c0mocqswcz*mmo*(1d0/4/ctw**4*vpaup*vpamn/us**2*mw**2-1d
     & 0/4/ctw**2*vpaup*vpamn*ts/us**2+1d0/4/ctw**2*vpaup*vpamn/us**2*mw
     & **2)
     & +propiwqs*c0mocqswcz*mmo**3*(1d0/4/ctw**2*vpaup*vpamn/qs/us**2*mw
     & **2+1d0/4/ctw**2*vpaup*vpamn/qs/us)
     & +propiwqs*c0mocqszmow*mmo*(1d0/4/ctw**4*vpadn*vpamo/us**2*mw**2+1
     & d0/4/ctw**2*vpaup*vmamo/ts-1d0/4/ctw**2*vpadn*vpamo*ts/us**2+1d0/
     & 4/ctw**2*vpadn*vpamo/us**2*mw**2-1d0/4/ctw**2*vpadn*vmamo/us)
     & +propiwqs*c0mocqszmow*mmo**3*(1d0/4/ctw**4*vpadn*vpamo/qs/us**2*m
     & w**2+1d0/4/ctw**2*vpaup*vmamo/qs/us+1d0/4/ctw**2*vpadn*vpamo/qs/u
     & s-1d0/4/ctw**2*vpadn*vpamo/us**2-1d0/4/ctw**2*vpadn*vmamo/qs/us)
     & +propiwqs*c0moctsmozc*mmo*(1d0/4/ctw**4*vpadn*vpamo/qs/us*mw**2-1
     & d0/4/ctw**4*vpadn*vpamo/us**2*mw**2+1d0/4/ctw**2*vpadn*vpamo/qs+1
     & d0/4/ctw**2*vpadn*vpamo*ts/us**2-1d0/4/ctw**2*vpadn*vpamo/us**2*m
     & w**2-1d0/4/ctw**2*vpadn*vpamo/us-1d0/4/ctw**2*vpadn*vmamo/qs+1d0/
     & 4/ctw**2*vpadn*vmamo/us)
     & +propiwqs*c0moctsmozc*mmo**3*(-1d0/4/ctw**2*vpadn*vpamo/ts/us**2*
     & mw**2+1d0/2/ctw**2*vpadn*vpamo/us**2)
     & +propiwqs*c0moctsmozc*mmo**5*(1d0/4/ctw**2*vpadn*vpamo/ts/us**2)
     & +propiwqs*c0moctscwc*mmo*(-1d0/4/ctw**4*vpaup*vpamn/us**2*mw**2+1
     & d0/4/ctw**2*vpaup*vpamn/qs/us*mw**2+1d0/4/ctw**2*vpaup*vpamn/qs+1
     & d0/4/ctw**2*vpaup*vpamn*ts/us**2-1d0/4/ctw**2*vpaup*vpamn/us**2*m
     & w**2-1d0/4/ctw**2*vpaup*vpamn/us)
     & +propiwqs*c0moctscwc*mmo**3*(-1d0/4/ctw**4*vpaup*vpamn/ts/us**2*m
     & w**2+1d0/4/ctw**2*vpaup*vpamn/us**2)
     & +propiwqs*c0mocusmozc*mmo*(-1d0/4/ctw**2*vpaup*vmamo/qs-1d0/4/ctw
     & **2*vpaup*vmamo/ts)
     & +propiwqs*c0mocusmozc*mmo**3*(-1d0/4/ctw**2*vpaup*vmamo/qs/us-1d0
     & /4/ctw**2*vpaup*vmamo/ts/us)
     & +propiwqs*c0ccqswcz*mmo*(1d0/4/ctw**4*vpaup*vpamn/ts/us*mw**2+1d0
     & /4/ctw**4*vpaup*vpamn/us**2*mw**2+1d0/4/ctw**4*vpadn*vpamo/us**2*
     & mw**2-1d0/4/ctw**2*vpaup*vpamn*ts/us**2+1d0/4/ctw**2*vpaup*vpamn/
     & us**2*mw**2+1d0/4/ctw**2*vpaup*vmamo/ts+1d0/4/ctw**2*vpadn*vpamo/
     & ts/us*mw**2-1d0/4/ctw**2*vpadn*vpamo*ts/us**2+1d0/4/ctw**2*vpadn*
     & vpamo/us**2*mw**2-1d0/4/ctw**2*vpadn*vmamo/us)
     & +propiwqs*c0ccqswcz*mmo**3*(1d0/4/ctw**4*vpaup*vpamn/ts/us**2*mw*
     & *2-1d0/4/ctw**2*vpaup*vpamn/us**2+1d0/4/ctw**2*vpaup*vmamo/ts/us+
     & 1d0/4/ctw**2*vpadn*vpamo/ts/us**2*mw**2-1d0/4/ctw**2*vpadn*vpamo/
     & ts/us-1d0/2/ctw**2*vpadn*vpamo/us**2)
     & +propiwqs*c0ccqswcz*mmo**5*(-1d0/4/ctw**2*vpadn*vpamo/ts/us**2)
     & +propiwqs*c0cctscwmo*mmo*(-1d0/4/ctw**4*vpadn*vpamo/qs/us*mw**2-1
     & d0/4/ctw**4*vpadn*vpamo/us**2*mw**2-1d0/4/ctw**2*vpadn*vpamo/qs+1
     & d0/4/ctw**2*vpadn*vpamo*ts/us**2-1d0/4/ctw**2*vpadn*vpamo/us**2*m
     & w**2-1d0/4/ctw**2*vpadn*vpamo/us+1d0/4/ctw**2*vpadn*vmamo/qs+1d0/
     & 4/ctw**2*vpadn*vmamo/us-ctw**2*qdn*qmo*ts/us**2+ctw**2*qdn*qmo/us
     & **2*mw**2+qdn*qmo*ts/us**2-qdn*qmo/us**2*mw**2)
     & +propiwqs*c0cctscwmo*mmo**3*(-1d0/4/ctw**4*vpadn*vpamo/qs/us**2*m
     & w**2-1d0/4/ctw**2*vpadn*vpamo/qs/us+1d0/4/ctw**2*vpadn*vpamo/us**
     & 2+1d0/4/ctw**2*vpadn*vmamo/qs/us-ctw**2*qdn*qmo/us**2+qdn*qmo/us*
     & *2)
     & +propiwqs*c0cctsczc*mmo*(-1d0/4/ctw**4*vpaup*vpamn/us**2*mw**2-1d
     & 0/4/ctw**2*vpaup*vpamn/qs/us*mw**2-1d0/4/ctw**2*vpaup*vpamn/qs+1d
     & 0/4/ctw**2*vpaup*vpamn*ts/us**2-1d0/4/ctw**2*vpaup*vpamn/us**2*mw
     & **2-1d0/4/ctw**2*vpaup*vpamn/us)
     & +propiwqs*c0cctsczc*mmo**3*(-1d0/4/ctw**2*vpaup*vpamn/qs/us**2*mw
     & **2-1d0/4/ctw**2*vpaup*vpamn/qs/us)
     & +propiwqs*c0ccuscwmo*mmo*(1d0/4/ctw**2*vpaup*vmamo/qs-1d0/4/ctw**
     & 2*vpaup*vmamo/ts-ctw**2*qup*qmo/qs+ctw**2*qup*qmo/ts+qup*qmo/qs-q
     & up*qmo/ts)
     & +propiwqs*a0fmo*mmo*(stw**2*qdn*qmo/ts/us)
     & +propiwqs*b0fmowc*mmo*(-1d0/4/ctw**2*vpaup*vpamn/ts/us)
     & +propiwqs*b0fmozmo*mmo*(-1d0/4/ctw**2*vpadn*vpamo/ts/us)
     & +propiwqs*b0fqswz*mmo*(1d0/4/ctw**2*vpaup*vpamn/ts/us+1d0/4/ctw**
     & 2*vpadn*vpamo/ts/us)
     & +propiwqs*b0fqswc*mmo*(-ctw**2*qdn*qmo/ts/us+qdn*qmo/ts/us)
     & +sdet3icmoqs*mmo*(-1d0/4/ctw**2*vpamn*vpamo+ctw**2*qmo-qmo+1d0/2*
     & vpamn-1d0/2*vpamo)
     & +sdet3icmoqs*mmo**3*(-1d0/8*vpamo/mw**2+1d0/8*vmamo/mw**2+1d0/8/m
     & w**2)
     & +sdet3icmoqs**2*mmo*(-2*ctw**2*qmo*mw**2+2*qmo*mw**2)
     & +sdet3icmoqs**2*mmo**3*(8*ctw**2*qmo-8*qmo)
     & +sdet3icmoqs**3*mmo**3*(6*ctw**2*qmo*mw**2-6*qmo*mw**2)
     & +sdet3icmoqs**3*mmo**5*(-6*ctw**2*qmo+6*qmo)
     & +sdet3icmoqs**3*c0mocqswcz*mmo**3*(-3/ctw**4*vpamn*mw**4)
     & +sdet3icmoqs**3*c0mocqszmow*mmo**3*(3*vpamo*mw**4)
     & +sdet3icmoqs**3*c0mocqszmow*mmo**5*(-21d0/4*vpamo*mw**2-3d0/4*vma
     & mo*mw**2)
     & +sdet3icmoqs**3*c0mocqszmow*mmo**7*(3d0/2*vpamo+3d0/2*vmamo)
     & +sdet3icmoqs**3*c0mocqszmow*mmo**9*(3d0/4*vpamo/mw**2-3d0/4*vmamo
     & /mw**2)
     & +sdet3icmoqs**3*c0mocqshmow*mmo**5*(-3d0/4*mw**2)
     & +sdet3icmoqs**3*c0mocqshmow*mmo**7*(3d0/2)
     & +sdet3icmoqs**3*c0mocqshmow*mmo**9*(-3d0/4/mw**2)
     & +sdet3icmoqs**3*c0mocqsmozc*mmo**3*(3d0/2/ctw**6*vpamn*vpamo*mw**
     & 4)
     & +sdet3icmoqs**3*c0mocqscmow*mmo**3*(-6*stw**2*mw**4)
     & +sdet3icmoqs**3*c0mocqscmow*mmo**5*(12*stw**2*mw**2)
     & +sdet3icmoqs**3*c0mocqscmow*mmo**7*(-6*stw**2)
     & +sdet3icmoqs**3*a0fmo*mmo**3*(6*stw**2*qmo*mw**2)
     & +sdet3icmoqs**3*a0fmo*mmo**5*(-6*stw**2*qmo)
     & +sdet3icmoqs**3*b0fmowc*mmo**3*(3/ctw**2*vpamn*mw**2)
     & +sdet3icmoqs**3*b0fmozmo*mmo**3*(3d0/2/ctw**4*vpamn*vpamo*mw**2-3
     & *vpamo*mw**2)
     & +sdet3icmoqs**3*b0fmozmo*mmo**5*(9d0/4*vpamo+3d0/4*vmamo)
     & +sdet3icmoqs**3*b0fmozmo*mmo**7*(3d0/4*vpamo/mw**2-3d0/4*vmamo/mw
     & **2)
     & +sdet3icmoqs**3*b0fmohmo*mmo**5*(3d0/4)
     & +sdet3icmoqs**3*b0fmohmo*mmo**7*(-3d0/4/mw**2)
     & +sdet3icmoqs**3*b0fqswz*mmo**3*(-3/ctw**2*vpamn*mw**2+3*vpamo*mw*
     & *2)
     & +sdet3icmoqs**3*b0fqswz*mmo**5*(-9d0/4*vpamo-3d0/4*vmamo)
     & +sdet3icmoqs**3*b0fqswz*mmo**7*(-3d0/4*vpamo/mw**2+3d0/4*vmamo/mw
     & **2)
     & +sdet3icmoqs**3*b0fqswh*mmo**5*(-3d0/4)
     & +sdet3icmoqs**3*b0fqswh*mmo**7*(3d0/4/mw**2)
     & +sdet3icmoqs**3*b0fqswc*mmo**3*(-6*ctw**2*qmo*mw**2+6*qmo*mw**2)
     & +sdet3icmoqs**3*b0fqswc*mmo**5*(6*ctw**2*qmo-6*qmo)
     & +sdet3icmoqs**3*b0fqsmoc*mmo**3*(-3d0/2/ctw**4*vpamn*vpamo*mw**2)
     & +sdet3icmoqs**2*c0mocqswcz*mmo*(1d0/ctw**4*vpamn*mw**4+2/ctw**2*v
     & pamn*mw**4)
     & +sdet3icmoqs**2*c0mocqswcz*mmo**3*(1d0/ctw**4*vpamn*mw**2-2/ctw**
     & 2*vpamn*mw**2)
     & +sdet3icmoqs**2*c0mocqszmow*mmo*(-2/ctw**2*vpamo*mw**4-vpamo*mw**
     & 4)
     & +sdet3icmoqs**2*c0mocqszmow*mmo**3*(3d0/2/ctw**2*vpamo*mw**2+1d0/
     & 2/ctw**2*vmamo*mw**2+19d0/4*vpamo*mw**2+13d0/4*vmamo*mw**2)
     & +sdet3icmoqs**2*c0mocqszmow*mmo**5*(1d0/2/ctw**2*vpamo-1d0/2/ctw*
     & *2*vmamo-2*vpamo-5*vmamo)
     & +sdet3icmoqs**2*c0mocqszmow*mmo**7*(-7d0/4*vpamo/mw**2+7d0/4*vmam
     & o/mw**2)
     & +sdet3icmoqs**2*c0mocqshmow*mmo**3*(-3d0/4*mw**2+1d0/2*mh**2)
     & +sdet3icmoqs**2*c0mocqshmow*mmo**5*(-1d0/2/mw**2*mh**2)
     & +sdet3icmoqs**2*c0mocqshmow*mmo**7*(3d0/4/mw**2)
     & +sdet3icmoqs**2*c0mocqsmozc*mmo*(-3d0/2/ctw**6*vpamn*vpamo*mw**4)
     & +sdet3icmoqs**2*c0mocqsmozc*mmo**3*(-1d0/ctw**4*vpamn*vpamo*mw**2
     & +1d0/ctw**4*vpamn*vmamo*mw**2)
     & +sdet3icmoqs**2*c0mocqscmow*mmo*(2*stw**2*mw**4)
     & +sdet3icmoqs**2*c0mocqscmow*mmo**3*(-16*stw**2*mw**2)
     & +sdet3icmoqs**2*c0mocqscmow*mmo**5*(14*stw**2)
     & +sdet3icmoqs**2*a0fw*mmo*(3*ctw**2*qmo*mw**2-3*qmo*mw**2-3d0/2*vp
     & amo*mw**2)
     & +sdet3icmoqs**2*a0fw*mmo**3*(3d0/8-3d0/8*vpamo+3d0/8*vmamo)
     & +sdet3icmoqs**2*a0fz*mmo*(3d0/4/ctw**4*vpamn*vpamo*mw**2+3d0/2/ct
     & w**2*vpamn*mw**2)
     & +sdet3icmoqs**2*a0fmo*mmo*(-2*stw**2*qmo*mw**2)
     & +sdet3icmoqs**2*a0fmo*mmo**3*(11*stw**2*qmo+3d0/2*vpamo)
     & +sdet3icmoqs**2*a0fmo*mmo**5*(3d0/8*vpamo/mw**2-3d0/8*vmamo/mw**2
     & -3d0/8/mw**2)
     & +sdet3icmoqs**2*b0fmowc*mmo*(-1d0/ctw**2*vpamn*mw**2-1d0/2*vpamn*
     & mw**2)
     & +sdet3icmoqs**2*b0fmowc*mmo**3*(-1d0/ctw**2*vpamn+1d0/2*vpamn)
     & +sdet3icmoqs**2*b0fmozmo*mmo*(-3d0/4/ctw**4*vpamn*vpamo*mw**2+1d0
     & /2/ctw**2*vpamo*mw**2+vpamo*mw**2)
     & +sdet3icmoqs**2*b0fmozmo*mmo**3*(-1d0/ctw**2*vpamn*vpamo+1d0/ctw*
     & *2*vpamn*vmamo+1d0/8/ctw**2*vpamo-1d0/8/ctw**2*vmamo-3d0/4*vpamo-
     & 13d0/4*vmamo)
     & +sdet3icmoqs**2*b0fmozmo*mmo**5*(-vpamo/mw**2+vmamo/mw**2)
     & +sdet3icmoqs**2*b0fmohmo*mmo**3*(3d0/4-1d0/8/mw**2*mh**2)
     & +sdet3icmoqs**2*b0fqswz*mmo*(5d0/2/ctw**2*vpamn*mw**2-1d0/2/ctw**
     & 2*vpamo*mw**2+1d0/2*vpamn*mw**2-5d0/2*vpamo*mw**2)
     & +sdet3icmoqs**2*b0fqswz*mmo**3*(1d0/ctw**2*vpamn-1d0/8/ctw**2*vpa
     & mo+1d0/8/ctw**2*vmamo-1d0/2*vpamn+15d0/8*vpamo+29d0/8*vmamo)
     & +sdet3icmoqs**2*b0fqswz*mmo**5*(11d0/8*vpamo/mw**2-11d0/8*vmamo/m
     & w**2)
     & +sdet3icmoqs**2*b0fqswh*mmo**3*(-3d0/8+1d0/8/mw**2*mh**2)
     & +sdet3icmoqs**2*b0fqswh*mmo**5*(-3d0/8/mw**2)
     & +sdet3icmoqs**2*b0fqswc*mmo*(5*ctw**2*qmo*mw**2-5*qmo*mw**2)
     & +sdet3icmoqs**2*b0fqswc*mmo**3*(-11*ctw**2*qmo+11*qmo)
     & +sdet3icmoqs**2*b0fqsmoc*mmo*(3d0/2/ctw**4*vpamn*vpamo*mw**2)
     & +sdet3icmoqs**2*b0fqsmoc*mmo**3*(1d0/ctw**2*vpamn*vpamo-1d0/ctw**
     & 2*vpamn*vmamo)
     & +sdet3icmoqs*c0mocqswcz*mmo*(-1d0/2/ctw**2*vpamn*mw**2)
     & +sdet3icmoqs*c0mocqswcz*mmo**3*(1d0/2/ctw**2*vpamn)
     & +sdet3icmoqs*c0mocqszmow*mmo*(1d0/2/ctw**2*vpamo*mw**2-2/ctw**2*v
     & mamo*mw**2-vmamo*mw**2)
     & +sdet3icmoqs*c0mocqszmow*mmo**3*(-1d0/4/ctw**2*vpamo+3d0/4/ctw**2
     & *vmamo-1d0/2*vpamo+9d0/2*vmamo)
     & +sdet3icmoqs*c0mocqszmow*mmo**5*(5d0/4*vpamo/mw**2-5d0/4*vmamo/mw
     & **2)
     & +sdet3icmoqs*c0mocqshmow*mmo*(1d0/2*mh**2)
     & +sdet3icmoqs*c0mocqshmow*mmo**3*(-1-1d0/4/mw**2*mh**2)
     & +sdet3icmoqs*c0mocqshmow*mmo**5*(1d0/4/mw**2)
     & +sdet3icmoqs*c0mocqsmozc*mmo*(2/ctw**4*vpamn*vpamo*mw**2-1d0/ctw*
     & *4*vpamn*vmamo*mw**2)
     & +sdet3icmoqs*c0mocqscmow*mmo*(-stw**2*qdn/ts*mw**4+stw**2*qdn/us*
     & mw**4+2*stw**2*mw**2)
     & +sdet3icmoqs*c0mocqscmow*mmo**3*(2*stw**2*qdn/ts*mw**2-2*stw**2*q
     & dn/us*mw**2-8*stw**2)
     & +sdet3icmoqs*c0mocqscmow*mmo**5*(-stw**2*qdn/ts+stw**2*qdn/us)
     & +sdet3icmoqs*a0fw/mmo*(-1d0/2*vpamn*mw**2)
     & +sdet3icmoqs*a0fw*mmo*(1d0/4+1d0/4*vpamo-1d0/4*vmamo+1d0/4*invfmo
     & w+2*invfmow*ctw**2*qmo-2*invfmow*qmo+1d0/4*invfmow*vpamo-5d0/4*in
     & vfmow*vmamo)
     & +sdet3icmoqs*a0fz/mmo*(-1d0/4/ctw**4*vpamn*vpamo*mw**2+1d0/2/ctw*
     & *2*vpamo*mw**2)
     & +sdet3icmoqs*a0fz*mmo*(-1d0/2/ctw**2*vpamn*vpamo+1d0/2/ctw**2*vpa
     & mn*vmamo-1d0/2/ctw**2*vpamn+1d0/8/ctw**2*vpamo-1d0/8/ctw**2*vmamo
     & )
     & +sdet3icmoqs*a0fh*mmo*(-1d0/8/mw**2*mh**2)
     & +sdet3icmoqs*a0fmo*mmo*(-stw**2*qmo+1d0/4/ctw**2*vpamn*vpamo-1d0/
     & 2*vpamo)
     & +sdet3icmoqs*a0fmo*mmo**3*(-3d0/8*vpamo/mw**2+3d0/8*vmamo/mw**2-1
     & d0/8/mw**2+2*invfmow*stw**2*qmo/mw**2-1d0/4*invfmow*vpamo/mw**2+5
     & d0/4*invfmow*vmamo/mw**2-1d0/4*invfmow/mw**2)
     & +sdet3icmoqs*b0fmowc/mmo*(-1d0/2*vpamn*mw**2)
     & +sdet3icmoqs*b0fmowc*mmo*(1d0/2*vpamn)
     & +sdet3icmoqs*b0fmozmo/mmo*(-1d0/4/ctw**4*vpamn*vpamo*mw**2+1d0/2/
     & ctw**2*vpamo*mw**2)
     & +sdet3icmoqs*b0fmozmo*mmo*(1d0/ctw**2*vpamn*vpamo-1d0/2/ctw**2*vp
     & amn*vmamo+1d0/8/ctw**2*vpamo+3d0/8/ctw**2*vmamo-vpamo+vmamo)
     & +sdet3icmoqs*b0fmozmo*mmo**3*(1d0/4*vpamo/mw**2-1d0/4*vmamo/mw**2
     & )
     & +sdet3icmoqs*b0fmohmo*mmo*(-1d0/8/mw**2*mh**2)
     & +sdet3icmoqs*b0fmohmo*mmo**3*(1d0/4/mw**2)
     & +sdet3icmoqs*b0fqswz*mmo*(-1d0/2/ctw**2*vpamn-1d0/2/ctw**2*vmamo-
     & 1d0/2*vpamn+vpamo-5d0/2*vmamo)
     & +sdet3icmoqs*b0fqswz*mmo**3*(-5d0/8*vpamo/mw**2+5d0/8*vmamo/mw**2
     & )
     & +sdet3icmoqs*b0fqswh*mmo*(1d0/2)
     & +sdet3icmoqs*b0fqswh*mmo**3*(-3d0/8/mw**2)
     & +sdet3icmoqs*b0fqswc*mmo*(3*ctw**2*qmo-3*qmo)
     & +sdet3icmoqs*b0fqsmoc*mmo*(-5d0/4/ctw**2*vpamn*vpamo+1d0/ctw**2*v
     & pamn*vmamo)
     & +sdet3icmots*c0mocqscmow*mmo*(stw**2*qdn/us*mw**4-stw**2*qdn*mw**
     & 2)
     & +sdet3icmots*c0mocqscmow*mmo**3*(stw**2*qdn/ts/us*mw**4-stw**2*qd
     & n/ts*mw**2-2*stw**2*qdn/us*mw**2+stw**2*qdn)
     & +sdet3icmots*c0mocqscmow*mmo**5*(-2*stw**2*qdn/ts/us*mw**2+stw**2
     & *qdn/ts+stw**2*qdn/us)
     & +sdet3icmots*c0mocqscmow*mmo**7*(stw**2*qdn/ts/us)
     & +sdet3icmous*c0mocqscmow*mmo**3*(-stw**2*qdn/qs*mw**2-stw**2*qdn-
     & stw**2/qs*mw**2-stw**2)
     & +sdet3icmous*c0mocqscmow*mmo**5*(-stw**2*qdn/qs/us*mw**2-stw**2*q
     & dn/us-stw**2/qs/us*mw**2-stw**2/us)
     & +javsubqstscmow*mmo*(-2*ctw**2*qdn*qmo*ts/us**2*mw**2+ctw**2*qdn*
     & qmo*ts/us+ctw**2*qdn*qmo*ts**2/us**2+ctw**2*qdn*qmo/us**2*mw**4-c
     & tw**2*qdn*qmo/us*mw**2+2*qdn*qmo*ts/us**2*mw**2-qdn*qmo*ts/us-qdn
     & *qmo*ts**2/us**2-qdn*qmo/us**2*mw**4+qdn*qmo/us*mw**2)
     & +javsubqstscmow*mmo**3*(ctw**2*qdn*qmo/ts/us**2*mw**4-ctw**2*qdn*
     & qmo/ts/us*mw**2+3*ctw**2*qdn*qmo*ts/us**2-4*ctw**2*qdn*qmo/us**2*
     & mw**2+2*ctw**2*qdn*qmo/us-qdn*qmo/ts/us**2*mw**4+qdn*qmo/ts/us*mw
     & **2-3*qdn*qmo*ts/us**2+4*qdn*qmo/us**2*mw**2-2*qdn*qmo/us)
     & +javsubqstscmow*mmo**5*(-2*ctw**2*qdn*qmo/ts/us**2*mw**2+ctw**2*q
     & dn*qmo/ts/us+3*ctw**2*qdn*qmo/us**2+2*qdn*qmo/ts/us**2*mw**2-qdn*
     & qmo/ts/us-3*qdn*qmo/us**2)
     & +javsubqstscmow*mmo**7*(ctw**2*qdn*qmo/ts/us**2-qdn*qmo/ts/us**2)
     & +javsubqsuscmow*mmo*(ctw**2*qup*qmo/qs*mw**2-ctw**2*qup*qmo/ts*us
     & +ctw**2*qup*qmo/ts*mw**2-qup*qmo/qs*mw**2+qup*qmo/ts*us-qup*qmo/t
     & s*mw**2)
     & +javsubqsuscmow*mmo**3*(ctw**2*qup*qmo/qs/us*mw**2+ctw**2*qup*qmo
     & /ts/us*mw**2-2*ctw**2*qup*qmo/ts-qup*qmo/qs/us*mw**2-qup*qmo/ts/u
     & s*mw**2+2*qup*qmo/ts)
     & +javsubqsuscmow*mmo**5*(-ctw**2*qup*qmo/ts/us+qup*qmo/ts/us)
     & +c0mocqszmow*mmo**3*(-1d0/4*vpamo/mw**2+1d0/4*vmamo/mw**2)
     & +c0mocqshmow*mmo**3*(-1d0/4/mw**2)
     & +c0mocqsmozc*mmo*(-1d0/2/ctw**2*vpamn*vpamo+1d0/2/ctw**2*vpamn*vm
     & amo)
     & +c0mocqscmow*mmo*(-stw**2*qdn/ts*mw**2)
     & +c0mocqscmow*mmo**3*(-stw**2*qdn/qs/us*mw**2+stw**2*qdn/ts-stw**2
     & *qdn/us-stw**2/qs/us*mw**2-stw**2/us)
     & +c0cctscwmo*mmo*(-2*ctw**2*qdn*qmo*ts/us**2*mw**2+ctw**2*qdn*qmo*
     & ts/us+ctw**2*qdn*qmo*ts**2/us**2+ctw**2*qdn*qmo/us**2*mw**4-ctw**
     & 2*qdn*qmo/us*mw**2+2*qdn*qmo*ts/us**2*mw**2-qdn*qmo*ts/us-qdn*qmo
     & *ts**2/us**2-qdn*qmo/us**2*mw**4+qdn*qmo/us*mw**2)
     & +c0cctscwmo*mmo**3*(ctw**2*qdn*qmo/ts/us**2*mw**4-ctw**2*qdn*qmo/
     & ts/us*mw**2+3*ctw**2*qdn*qmo*ts/us**2-4*ctw**2*qdn*qmo/us**2*mw**
     & 2+2*ctw**2*qdn*qmo/us-qdn*qmo/ts/us**2*mw**4+qdn*qmo/ts/us*mw**2-
     & 3*qdn*qmo*ts/us**2+4*qdn*qmo/us**2*mw**2-2*qdn*qmo/us)
     & +c0cctscwmo*mmo**5*(-2*ctw**2*qdn*qmo/ts/us**2*mw**2+ctw**2*qdn*q
     & mo/ts/us+3*ctw**2*qdn*qmo/us**2+2*qdn*qmo/ts/us**2*mw**2-qdn*qmo/
     & ts/us-3*qdn*qmo/us**2)
     & +c0cctscwmo*mmo**7*(ctw**2*qdn*qmo/ts/us**2-qdn*qmo/ts/us**2)
     & +c0ccuscwmo*mmo*(ctw**2*qup*qmo/qs*mw**2-ctw**2*qup*qmo/ts*us+ctw
     & **2*qup*qmo/ts*mw**2-qup*qmo/qs*mw**2+qup*qmo/ts*us-qup*qmo/ts*mw
     & **2)
     & +c0ccuscwmo*mmo**3*(ctw**2*qup*qmo/qs/us*mw**2+ctw**2*qup*qmo/ts/
     & us*mw**2-2*ctw**2*qup*qmo/ts-qup*qmo/qs/us*mw**2-qup*qmo/ts/us*mw
     & **2+2*qup*qmo/ts)
     & +c0ccuscwmo*mmo**5*(-ctw**2*qup*qmo/ts/us+qup*qmo/ts/us)

      ff_ew_rd =
     & 0

      ffarray(1,1) = ff_ew_ll
      ffarray(1,2) = ff_ew_ld
      ffarray(1,3) = ff_ew_rd

      return
      end
