************************************************************************
* File (cc_ha_2221_1615.f) created on Tue May 26 22:59:25 MSD 2009.
************************************************************************
* This is the FORTRAN module (cc_ha_2221_1615) to calculate differential
* hard photon Bremsstrahlung for the tp -> bt + mo + mn.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2009.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine cc_ha_2221_1615 (s,spr,ph4,costh4,costh5,hard)
      implicit none!
      include 's2n_declare.h'

      real*8 qw,sq,sqspr
      real*8 p1p2,p1p3,p1p4,p1p5,p2p3,p2p4,p2p5,p3p4,p3p5,p4p5
      real*8 ph4,cosph4,sinph4,costh4,sinth4,costh5,sinth5
      real*8 sqrtltpbts,isqrtltpbts
      complex*16 propwspr,propiwspr,propwsprc,propws,propiws,propwsc
      real*8 iz1bt,iz2tp,iz3mn,iz4mo

      cmw2 = mw2
      qw   = 1d0

      sq = dsqrt(s)
      sqspr = dsqrt(spr)

      cosph4 = dcos(ph4)
      sinph4 = dsin(ph4)
      sinth4 = dsqrt(1d0-costh4**2)
      sinth5 = dsqrt(1d0-costh5**2)

      if (irun.eq.0) then
         propiwspr = (cmw2-spr)
      elseif (irun.eq.1) then
         propiwspr = (dcmplx(mw**2,-spr*ww/mw)-spr)
      endif
      propwspr = 1d0/propiwspr
      propwsprc = dconjg(propwspr)
      if (irun.eq.0) then
         propiws = (cmw2-s)
      elseif (irun.eq.1) then
         propiws = (dcmplx(mw**2,-s*ww/mw)-s)
      endif
      propws = 1d0/propiws
      propwsc = dconjg(propws)
      sqrtltpbts = sqrt(rtpm2**2-2d0*rtpm2*(rbtm2+s)+(rbtm2-s)**2)
      isqrtltpbts = 1d0/sqrtltpbts

      p1p5=
     & +costh5*(-1d0/4*mtp**2/s*spr+1d0/4*mtp**2-1d0/4*s+1d0/4*spr)
     & +1d0/4*mtp**2/s*spr-1d0/4*mtp**2+1d0/4*s-1d0/4*spr

      p2p5=
     & +costh5*(-1d0/4*mtp**2/s*spr+1d0/4*mtp**2-1d0/4*s+1d0/4*spr)
     & +1d0/4*mtp**2/s*spr-1d0/4*mtp**2-1d0/4*s+1d0/4*spr

      p3p5=
     & +costh4*(-1d0/4*s+1d0/4*spr)
     & -1d0/4*s+1d0/4*spr

      p4p5=
     & +costh4*(1d0/4*s-1d0/4*spr)
     & -1d0/4*s+1d0/4*spr

      p1p2=
     & -1d0/2*mtp**2+1d0/2*s

      p1p4=
     & +sinph4*sinth4*sinth5*(-1d0/4*sqspr/sq*mtp**2+1d0/4*sqspr/sq*s)
     & +costh4*costh5*(1d0/8*mtp**2/s*spr+1d0/8*mtp**2-1d0/8*s-1d0/8*spr
     & )
     & +costh4*(-1d0/8*mtp**2/s*spr+1d0/8*mtp**2-1d0/8*s+1d0/8*spr)
     & +costh5*(1d0/8*mtp**2/s*spr-1d0/8*mtp**2+1d0/8*s-1d0/8*spr)
     & -1d0/8*mtp**2/s*spr-1d0/8*mtp**2+1d0/8*s+1d0/8*spr

      p2p4=
     & +sinph4*sinth4*sinth5*(-1d0/4*sqspr/sq*mtp**2+1d0/4*sqspr/sq*s)
     & +costh4*costh5*(1d0/8*mtp**2/s*spr+1d0/8*mtp**2-1d0/8*s-1d0/8*spr
     & )
     & +costh4*(-1d0/8*mtp**2/s*spr+1d0/8*mtp**2+1d0/8*s-1d0/8*spr)
     & +costh5*(1d0/8*mtp**2/s*spr-1d0/8*mtp**2+1d0/8*s-1d0/8*spr)
     & -1d0/8*mtp**2/s*spr-1d0/8*mtp**2-1d0/8*s-1d0/8*spr

      p3p4=
     & -1d0/2*spr

      p1p3=
     & +sinph4*sinth4*sinth5*(1d0/4*sqspr/sq*mtp**2-1d0/4*sqspr/sq*s)
     & +costh4*costh5*(-1d0/8*mtp**2/s*spr-1d0/8*mtp**2+1d0/8*s+1d0/8*sp
     & r)
     & +costh4*(1d0/8*mtp**2/s*spr-1d0/8*mtp**2+1d0/8*s-1d0/8*spr)
     & +costh5*(1d0/8*mtp**2/s*spr-1d0/8*mtp**2+1d0/8*s-1d0/8*spr)
     & -1d0/8*mtp**2/s*spr-1d0/8*mtp**2+1d0/8*s+1d0/8*spr

      p2p3=
     & +sinph4*sinth4*sinth5*(1d0/4*sqspr/sq*mtp**2-1d0/4*sqspr/sq*s)
     & +costh4*costh5*(-1d0/8*mtp**2/s*spr-1d0/8*mtp**2+1d0/8*s+1d0/8*sp
     & r)
     & +costh4*(1d0/8*mtp**2/s*spr-1d0/8*mtp**2-1d0/8*s+1d0/8*spr)
     & +costh5*(1d0/8*mtp**2/s*spr-1d0/8*mtp**2+1d0/8*s-1d0/8*spr)
     & -1d0/8*mtp**2/s*spr-1d0/8*mtp**2-1d0/8*s-1d0/8*spr

      iz1bt=
     & +1d0/(mbt**2/s+1d0/4*sqrtltpbts**2*sinth5**2/s**2)/(s-spr)*(-1d0/
     & 2+1d0/2*mtp**2/s-1d0/2*mbt**2/s+1d0/2*sqrtltpbts*costh5/s)

      iz2tp=
     & +1d0/(mtp**2/s+1d0/4*sqrtltpbts**2*sinth5**2/s**2)/(s-spr)*(1d0/2
     & +1d0/2*mtp**2/s-1d0/2*mbt**2/s+1d0/2*sqrtltpbts*costh5/s)

      iz3mn=
     & +1d0/(1d0/4*sinth4**2-1d0/2*sinth4**2*mmo**2/spr+1d0/4*sinth4**2*
     & mmo**4/spr**2)/(s-spr)*(1d0/2-1d0/2*mmo**2/spr-1d0/2*costh4+1d0/2
     & *costh4*mmo**2/spr)

      iz4mo=
     & +1d0/(mmo**2/spr+1d0/4*sinth4**2-1d0/2*sinth4**2*mmo**2/spr+1d0/4
     & *sinth4**2*mmo**4/spr**2)/(s-spr)*(1d0/2+1d0/2*mmo**2/spr+1d0/2*c
     & osth4-1d0/2*costh4*mmo**2/spr)

      hardisr=
     & +iz1bt**2*propwspr*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qbt**2*
     & mw**4/mtp**3*mbt**2/s*(s-spr)*(-1d0/32*p1p3*p2p4-1d0/32*p2p4*p3p5
     & )
     & +iz1bt*propwspr*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qtp*qbt*mw
     & **4/mtp**3/s*(s-spr)*(1d0/64*p1p3*p1p4+1d0/64*p1p3*p2p4)
     & +iz1bt*propwspr*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qtp*qbt*mw
     & **4/mtp**3/s*(-1d0/16*p1p2*p1p3*p2p4+1d0/32*p1p2*p1p3*p4p5-1d0/32
     & *p1p2*p2p4*p3p5)
     & +iz1bt*propwspr*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qbt*mw**4/
     & mtp**3/s*(s-spr)*(-1d0/64*p1p3*p1p4*qw-1d0/64*p1p3*p2p4*qw)
     & +iz1bt*propwspr*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qbt*mw**4/
     & mtp**3/s*(1d0/16*p1p2*p1p3*p2p4*qw-1d0/32*p1p2*p1p3*p4p5*qw+1d0/3
     & 2*p1p2*p2p4*p3p5*qw)
     & +iz1bt*propwspr*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qbt**2*mw*
     & *4/mtp**3/s*(s-spr)*(1d0/64*p2p4*p3p5)
     & +iz2tp**2*propwspr*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qtp**2*
     & mw**4/mtp/s*(s-spr)*(-1d0/32*p1p3*p2p4+1d0/32*p1p3*p4p5)
     & +iz2tp*propwspr*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qtp*qbt*mw
     & **4/mtp**3/s*(s-spr)*(-1d0/64*p1p3*p2p4-1d0/64*p2p3*p2p4)
     & +iz2tp*propwspr*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qtp*qbt*mw
     & **4/mtp**3/s*(1d0/16*p1p2*p1p3*p2p4-1d0/32*p1p2*p1p3*p4p5+1d0/32*
     & p1p2*p2p4*p3p5)
     & +iz2tp*propwspr*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qtp*mw**4/
     & mtp**3/s*(s-spr)*(-1d0/64*p1p3*p2p4*qw-1d0/64*p2p3*p2p4*qw)
     & +iz2tp*propwspr*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qtp*mw**4/
     & mtp**3/s*(1d0/16*p1p2*p1p3*p2p4*qw-1d0/32*p1p2*p1p3*p4p5*qw+1d0/3
     & 2*p1p2*p2p4*p3p5*qw)
     & +iz2tp*propwspr*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qtp*mw**4/
     & mtp/s*(1d0/16*p1p3*p2p4*qw-1d0/16*p1p3*p4p5*qw)
     & +iz2tp*propwspr*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qtp**2*mw*
     & *4/mtp**3/s*(s-spr)*(1d0/64*p1p3*p4p5)
     & +propwspr*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qtp*mw**4/mtp**3
     & /s*(1d0/64*p1p3*p2p4*qw+1d0/64*p1p3*p3p4*qw-1d0/64*p1p3*p4p5*qw+1
     & d0/64*p2p3*p2p4*qw)
     & +propwspr*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qbt*mw**4/mtp**3
     & /s*(-1d0/64*p1p3*p1p4*qw-1d0/64*p1p3*p2p4*qw+1d0/64*p2p4*p3p4*qw-
     & 1d0/64*p2p4*p3p5*qw)
     & +propwspr*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*mw**4/mtp**3/s/(
     & s-spr)*(1d0/32*p1p2*p1p3*p4p5*qw**2-1d0/32*p1p2*p2p4*p3p5*qw**2+1
     & d0/32*p1p3*p2p5*p3p4*qw**2+1d0/32*p1p5*p2p4*p3p4*qw**2)
     & +propwspr*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*mw**4/mtp**3/(s-
     & spr)*(-1d0/32*p1p3*p2p4*qw**2)
     & +propwspr*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*mw**4/mtp/s/(s-s
     & pr)*(1d0/32*p1p3*p4p5*qw**2)

      hardfsr=
     & +iz4mo**2*propws*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*qmo**2*mw**
     & 4*mmo**2/mtp**3/s*(s-spr)*(-1d0/32*p1p3*p2p4-1d0/32*p1p3*p2p5)
     & +iz4mo*propws*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*mw**4/mtp*
     & *3/s*(s-spr)*(-1d0/64*p1p3*p2p4*qw+1d0/64*p1p4*p2p4*qw)
     & +iz4mo*propws*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*mw**4/mtp*
     & *3/s*(1d0/16*p1p3*p2p4*p3p4*qw+1d0/32*p1p3*p2p5*p3p4*qw+1d0/32*p1
     & p5*p2p4*p3p4*qw)
     & +iz4mo*propws*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*qmo**2*mw**4/m
     & tp**3/s*(s-spr)*(1d0/64*p1p3*p2p5)
     & +propws*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*mw**4/mtp**3/s*(
     & -1d0/64*p1p2*p1p3*qw-1d0/64*p1p3*p2p4*qw+1d0/64*p1p3*p2p5*qw-1d0/
     & 64*p1p4*p2p4*qw)
     & +propws*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*mw**4/mtp/s*(-1d
     & 0/64*p1p3*qw)
     & +propws*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*mw**4/mtp**3/s/(s-sp
     & r)*(1d0/32*p1p2*p1p3*p4p5*qw**2-1d0/32*p1p2*p2p4*p3p5*qw**2+1d0/3
     & 2*p1p3*p2p5*p3p4*qw**2+1d0/32*p1p5*p2p4*p3p4*qw**2)
     & +propws*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*mw**4/mtp**3/(s-spr)
     & *(-1d0/32*p1p3*p2p4*qw**2)
     & +propws*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*mw**4/mtp/s/(s-spr)*
     & (1d0/32*p1p3*p4p5*qw**2)

      hardifi=
     & +iz1bt*iz4mo*propws*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*qb
     & t*mw**4/mtp**3/s*(s-spr)*(-1d0/32*p1p3*p1p4*p2p4)
     & +iz1bt*iz4mo*propws*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*qb
     & t*mw**4/mtp**3/s*(s-spr)**2*(1d0/128*p1p3*p1p4+1d0/128*p1p4*p2p4)
     & 
     & +iz1bt*iz4mo*propwspr*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*qb
     & t*mw**4/mtp**3/s*(s-spr)*(-1d0/32*p1p3*p1p4*p2p4)
     & +iz1bt*iz4mo*propwspr*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*qb
     & t*mw**4/mtp**3/s*(s-spr)**2*(1d0/128*p1p3*p1p4+1d0/128*p1p4*p2p4)
     & 
     & +iz1bt*propws*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*qbt*mw**
     & 4/mtp**3/s*(s-spr)*(-1d0/128*p1p2*p1p3+1d0/128*p1p3*p2p4-1d0/128*
     & p1p4*p2p4)
     & +iz1bt*propws*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qbt*mw**4/mt
     & p**3/s*(s-spr)*(1d0/128*p1p3*p1p4*qw+1d0/128*p1p3*p2p4*qw)
     & +iz1bt*propws*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qbt*mw**4/mt
     & p**3/s*(-1d0/32*p1p2*p1p3*p2p4*qw+1d0/64*p1p2*p1p3*p4p5*qw-1d0/64
     & *p1p2*p2p4*p3p5*qw)
     & +iz1bt*propwspr*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*qbt*mw**
     & 4/mtp**3/s*(s-spr)*(-1d0/128*p1p2*p1p3+1d0/128*p1p3*p2p4-1d0/128*
     & p1p4*p2p4)
     & +iz1bt*propwspr*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*qbt*mw**4/mt
     & p**3/s*(s-spr)*(1d0/128*p1p3*p1p4*qw+1d0/128*p1p3*p2p4*qw)
     & +iz1bt*propwspr*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*qbt*mw**4/mt
     & p**3/s*(-1d0/32*p1p2*p1p3*p2p4*qw+1d0/64*p1p2*p1p3*p4p5*qw-1d0/64
     & *p1p2*p2p4*p3p5*qw)
     & +iz2tp*iz4mo*propws*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*qt
     & p*mw**4/mtp**3/s*(s-spr)*(1d0/32*p1p3*p2p4**2)
     & +iz2tp*iz4mo*propwspr*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*qt
     & p*mw**4/mtp**3/s*(s-spr)*(1d0/32*p1p3*p2p4**2)
     & +iz2tp*propws*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*qtp*mw**
     & 4/mtp**3/s*(s-spr)*(1d0/64*p1p3*p2p4)
     & +iz2tp*propws*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*qtp*mw**
     & 4/mtp/s*(s-spr)*(-1d0/128*p1p3)
     & +iz2tp*propws*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qtp*mw**4/mt
     & p**3/s*(s-spr)*(1d0/128*p1p3*p2p4*qw+1d0/128*p2p3*p2p4*qw)
     & +iz2tp*propws*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qtp*mw**4/mt
     & p**3/s*(-1d0/32*p1p2*p1p3*p2p4*qw+1d0/64*p1p2*p1p3*p4p5*qw-1d0/64
     & *p1p2*p2p4*p3p5*qw)
     & +iz2tp*propws*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qtp*mw**4/mt
     & p/s*(-1d0/32*p1p3*p2p4*qw+1d0/32*p1p3*p4p5*qw)
     & +iz2tp*propwspr*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*qtp*mw**
     & 4/mtp**3/s*(s-spr)*(1d0/64*p1p3*p2p4)
     & +iz2tp*propwspr*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*qtp*mw**
     & 4/mtp/s*(s-spr)*(-1d0/128*p1p3)
     & +iz2tp*propwspr*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*qtp*mw**4/mt
     & p**3/s*(s-spr)*(1d0/128*p1p3*p2p4*qw+1d0/128*p2p3*p2p4*qw)
     & +iz2tp*propwspr*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*qtp*mw**4/mt
     & p**3/s*(-1d0/32*p1p2*p1p3*p2p4*qw+1d0/64*p1p2*p1p3*p4p5*qw-1d0/64
     & *p1p2*p2p4*p3p5*qw)
     & +iz2tp*propwspr*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*qtp*mw**4/mt
     & p/s*(-1d0/32*p1p3*p2p4*qw+1d0/32*p1p3*p4p5*qw)
     & +iz4mo*propws*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*qtp*mw**
     & 4/mtp**3/s*(s-spr)*(-1d0/64*p1p3*p2p4)
     & +iz4mo*propws*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*qbt*mw**
     & 4/mtp**3/s*(s-spr)*(1d0/128*p1p3*p1p4+1d0/128*p1p3*p2p4-1d0/128*p
     & 2p4*p3p4)
     & +iz4mo*propws*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*mw**4/mt
     & p**3/s*(s-spr)*(1d0/128*p1p3*p2p4*qw-1d0/128*p1p4*p2p4*qw)
     & +iz4mo*propws*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*mw**4/mt
     & p**3/s*(-1d0/32*p1p3*p2p4*p3p4*qw-1d0/64*p1p3*p2p5*p3p4*qw-1d0/64
     & *p1p5*p2p4*p3p4*qw)
     & +iz4mo*propwspr*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*qtp*mw**
     & 4/mtp**3/s*(s-spr)*(-1d0/64*p1p3*p2p4)
     & +iz4mo*propwspr*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*qbt*mw**
     & 4/mtp**3/s*(s-spr)*(1d0/128*p1p3*p1p4+1d0/128*p1p3*p2p4-1d0/128*p
     & 2p4*p3p4)
     & +iz4mo*propwspr*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*mw**4/mt
     & p**3/s*(s-spr)*(1d0/128*p1p3*p2p4*qw-1d0/128*p1p4*p2p4*qw)
     & +iz4mo*propwspr*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*mw**4/mt
     & p**3/s*(-1d0/32*p1p3*p2p4*p3p4*qw-1d0/64*p1p3*p2p5*p3p4*qw-1d0/64
     & *p1p5*p2p4*p3p4*qw)
     & +propws*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*qtp*mw**4/mtp*
     & *3/s*(s-spr)*(-1d0/128*p1p3)
     & +propws*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*mw**4/mtp**3/s
     & *(1d0/128*p1p2*p1p3*qw+1d0/128*p1p3*p2p4*qw-1d0/128*p1p3*p2p5*qw+
     & 1d0/128*p1p4*p2p4*qw)
     & +propws*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*mw**4/mtp/s*(1
     & d0/128*p1p3*qw)
     & +propws*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qtp*mw**4/mtp**3/s
     & *(-1d0/128*p1p3*p2p4*qw-1d0/128*p1p3*p3p4*qw+1d0/128*p1p3*p4p5*qw
     & -1d0/128*p2p3*p2p4*qw)
     & +propws*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*qbt*mw**4/mtp**3/s
     & *(1d0/128*p1p3*p1p4*qw+1d0/128*p1p3*p2p4*qw-1d0/128*p2p4*p3p4*qw+
     & 1d0/128*p2p4*p3p5*qw)
     & +propws*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*mw**4/mtp**3/s/(s-
     & spr)*(-1d0/32*p1p2*p1p3*p4p5*qw**2+1d0/32*p1p2*p2p4*p3p5*qw**2-1d
     & 0/32*p1p3*p2p5*p3p4*qw**2-1d0/32*p1p5*p2p4*p3p4*qw**2)
     & +propws*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*mw**4/mtp**3/(s-sp
     & r)*(1d0/32*p1p3*p2p4*qw**2)
     & +propws*propwsprc*(mtp**2-s)/pi**5*alpha*gf**2*mw**4/mtp/s/(s-spr
     & )*(-1d0/32*p1p3*p4p5*qw**2)
     & +propwspr*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*qtp*mw**4/mtp*
     & *3/s*(s-spr)*(-1d0/128*p1p3)
     & +propwspr*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*mw**4/mtp**3/s
     & *(1d0/128*p1p2*p1p3*qw+1d0/128*p1p3*p2p4*qw-1d0/128*p1p3*p2p5*qw+
     & 1d0/128*p1p4*p2p4*qw)
     & +propwspr*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*qmo*mw**4/mtp/s*(1
     & d0/128*p1p3*qw)
     & +propwspr*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*qtp*mw**4/mtp**3/s
     & *(-1d0/128*p1p3*p2p4*qw-1d0/128*p1p3*p3p4*qw+1d0/128*p1p3*p4p5*qw
     & -1d0/128*p2p3*p2p4*qw)
     & +propwspr*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*qbt*mw**4/mtp**3/s
     & *(1d0/128*p1p3*p1p4*qw+1d0/128*p1p3*p2p4*qw-1d0/128*p2p4*p3p4*qw+
     & 1d0/128*p2p4*p3p5*qw)
     & +propwspr*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*mw**4/mtp**3/s/(s-
     & spr)*(-1d0/32*p1p2*p1p3*p4p5*qw**2+1d0/32*p1p2*p2p4*p3p5*qw**2-1d
     & 0/32*p1p3*p2p5*p3p4*qw**2-1d0/32*p1p5*p2p4*p3p4*qw**2)
     & +propwspr*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*mw**4/mtp**3/(s-sp
     & r)*(1d0/32*p1p3*p2p4*qw**2)
     & +propwspr*propwsc*(mtp**2-s)/pi**5*alpha*gf**2*mw**4/mtp/s/(s-spr
     & )*(-1d0/32*p1p3*p4p5*qw**2)

      if (iqed.eq.1) then
         hard = hardisr+hardifi+hardfsr
      elseif(iqed.eq.2) then
         hard = hardisr
      elseif(iqed.eq.3) then
         hard = hardifi
      elseif(iqed.eq.4) then
         hard = hardfsr
      elseif(iqed.eq.5) then
         hard = hardifi+hardfsr
      endif

      hard = hard*cfprime

      return
      end
